//---------------------------------------------------------------------------
// Madoka Demo 2006 ܂ǂ̎Ȗ3Df2006  
//
// CLogoSceneMan.cpp Logo\V[SV[}NX
//
//                   ̃V[}NXLogo\V[SłB
//                   Logo\V[ł"Madoka Demo 2006"ƍ
//                   \܂B
// 
// Programmed by Mikio Kusaka With Microsoft Visual C++ .Net2003
//
//---------------------------------------------------------------------------
#include "CLogoSceneMan.h"
#include <mbString.h>
#include <math.h>
//---------------------------------------------------------------------------
// 萔 
//---------------------------------------------------------------------------
#define LOGO_SCENE_END_TIME			   (12000)		//̃V[̕\[ms]
#define LOGO_BLUR_START_TIME			(8000)		//u[Jn
													//(V[Jňoߎ[ms])
#define LOGO_FADEIN_END_TIME			(3000)		//tF[hCI
													//(V[Jňoߎ[ms])
#define LOGO_FADEOUT_START_TIME		   (10000)		//tF[hAEgJn
													//(V[Jňoߎ[ms])

#define LOGO_DOT_DIFFUSE_R				(1.0f)		//ShbgF(R)
#define LOGO_DOT_DIFFUSE_G				(1.0f)		//ShbgF(G)
#define LOGO_DOT_DIFFUSE_B				(0.0f)		//ShbgF(B)
#define LOGO_FADE_IN_DIFFUSE_R			(1.0f)		//tF[hCF(R)
#define LOGO_FADE_IN_DIFFUSE_G			(1.0f)		//tF[hCF(G)
#define LOGO_FADE_IN_DIFFUSE_B			(1.0f)		//tF[hCF(B)
#define LOGO_FADEOUT_DIFFUSE_R			(1.0f)		//tF[hAEgF(R)
#define LOGO_FADEOUT_DIFFUSE_G			(1.0f)		//tF[hAEgF(G)
#define LOGO_FADEOUT_DIFFUSE_B			(1.0f)		//tF[hAEgF(B)

#define LOGO_STRING						"Madoka Demo 2006"

//---------------------------------------------------------------------------
// f[^^萔 
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// \̒` 
//---------------------------------------------------------------------------
//Logo\V[pIuWFNgړǗp\
//K\̂̃TCYSCENE_OBJECT_WORK_SPACEȉ
//Ȃ悤ɂĂB
#pragma pack(1)
typedef struct tag_Logo_Object_State_Type
{
	int   x,y;			//݈ʒu							8
	BYTE  byAlpha;		//\l							1

	//ȍ~̓|Sp̎w
	float fDiffuseR;	//gURl						4
	float fDiffuseG;	//gUGl						4
	float fDiffuseB;	//gUBl						4
	
	float fAddAlpha;	//tF[hAEgp|S		4
						//l

	int  iAngle;		//IuWFNg̏p[x]			4

} LOGO_OBJECT_STATE_TYPE;						 //size =  29 
#pragma pack()

//---------------------------------------------------------------------------
// CLogoSceneManNX 
//---------------------------------------------------------------------------
CLogoSceneMan::CLogoSceneMan(CRenderingMan *pRenderingMan)
			     : CSceneManBase(pRenderingMan)
{			

	//RXgN^

	//Logo\V[}ł͓ɂ邱Ƃ܂

}
//---------------------------------------------------------------------------
CLogoSceneMan::~CLogoSceneMan()
{

	//fXgN^
	
	//Logo\V[}ł͓ɂ邱Ƃ܂

}
//---------------------------------------------------------------------------
void CLogoSceneMan::CreateScene(void)
{

	//V[IuWFNg̍\z

	//ȑÔ̂폜
	DeleteSceneObject();

	//{ϊsݒIuWFNgǗ쐬
	CreateMatrixSetObjInfo();
	
	//SIuWFNgǗ쐬
	CreateLogoObjInfo();

	//V[Jn
	m_bSceneStart = true;
	m_bSceneEnd   = false;
}
//---------------------------------------------------------------------------
void CLogoSceneMan::DeleteScene(void)
{

	//V[IuWFNg̍폜

	DeleteSceneObject();
	m_bSceneStart = false;	
}
//---------------------------------------------------------------------------
void CLogoSceneMan::CreateMatrixSetObjInfo(void)
{

	//{ϊsݒIuWFNgǗ쐬

	//IuWFNgǗ\z
	OBJECT_STATE_TYPE *pMatrixObjState = new OBJECT_STATE_TYPE;
	
	//IuWFNg̐Ԃݒ
	pMatrixObjState->dwAliveTime[0] = 0;
	pMatrixObjState->dwAliveTime[1] = LOGO_SCENE_END_TIME;
	
	//֐̐ݒ
	pMatrixObjState->pFunc = (LPOBJECT_FUNC)(CLogoSceneMan::MatrixSetFunc);

	//IuWFNgXgɒǉ
	m_vecObjectList.push_back(pMatrixObjState);

	//ɒl̕ςȂsݒ肵Ă
	
	//ϊs쐬
	//W͍Wn
	CMatrixMan4 mProjection;
	
	//s
	mProjection.Initialize();

	//ˉeϊs쐬
	//ŋߓ_Eŉ_EpEpc̏Őݒ
	mProjection.Projection2(0.0f,1000.0f,		//ZlL͈͂Min,Max
							60.0f * RAD,		//p
							60.0f * RAD);		//pc
	
	//ˉeϊsZbg
	m_pRenderingMan->SetProjectionMatrix(mProjection);

	//r[|[gݒ
	m_pRenderingMan->SetViewPort(0.0f,0.0f,(float)SCREEN_WIDTH,(float)SCREEN_HEIGHT);

}
//---------------------------------------------------------------------------
void CLogoSceneMan::CreateLogoObjInfo(void)
{

	//SIuWFNgǗ쐬

	char *pszLogString = LOGO_STRING;

	//SA`GCAXƂăɕ`悵A
	//hbg̈ʒu擾B
	//Ẵhbg̈ʒuɃltŃL[u^Iu
	//WFNgׂĉ猩Ă݂iOO

	int iBaseX = 0;	
	int iBaseY = 0;
	UINT uiChar;	//`悷镶̃}`oCgR[h
	HDC  hDC = m_pRenderingMan->GetDC();	//`HDC擾

	while((uiChar = _mbsnextc((BYTE*)pszLogString)) != 0)
	{
		//`ɕKvȃTCY擾
		GLYPHMETRICS	tGlyph;			//OtgbNXp\
		BYTE           *pAlphaBuff;		//̃hbg̃lobt@
		DWORD			dwBUffSize;		//lobt@̃obt@TCY
		MAT2 tMat2 =
		{ { 0, 1, }, { 0, 0, }, { 0, 0, }, { 0, 1, } };	//`ps
														//(Ƃ肠PʍsɂȂĂ܂)
		
		//Kvȃobt@̃TCY𒲂ׂ
		dwBUffSize = GetGlyphOutline(hDC,uiChar,GGO_GRAY8_BITMAP,
									 &tGlyph,0,NULL,&tMat2);
		
		if(dwBUffSize > 0)
		{
			//lobt@̃m
			pAlphaBuff = new BYTE[dwBUffSize];

			//w̃̕AEgC(l)擾
			GetGlyphOutline(hDC,uiChar,GGO_GRAY4_BITMAP,
							&tGlyph,dwBUffSize,pAlphaBuff,&tMat2);
			int iXOffset = tGlyph.gmCellIncX;	//̕ւXItZbg擾

			//݂̃tHg̃x[XCʒu擾
			TEXTMETRIC tTextMet;
			GetTextMetrics(hDC,&tTextMet);

			//擾AEgCɉăsNZ`
			int x,y;
			int x_Max = tGlyph.gmBlackBoxX;
			int y_Max = tGlyph.gmBlackBoxY;
			int iLineBytes = (tGlyph.gmBlackBoxX + 3) & 0xFFFFFFFC;	//4oCgEȂ̂
			BYTE *pAlpha = pAlphaBuff;
			
			for(y = 0;y < y_Max;++y)
			{
				for(x = 0;x < x_Max;++x)
				{
					//_ł(IuWFNgݒ)
					if(pAlpha[x] > 0)
					{
						//lGGO_GRAY4_BITMAPŎ擾ꍇA
						//0`16܂ł17KȂ̂ŁA0`255ɍ킹
						//߁A~16-1ŌvZ܂B
						//
						//Ȃ݂ɁAGGO_GRAY8_BITMAPŎ擾ꍇ
						//0`6465KɂȂ̂łAڂɂ17
						//KƂقǍȂɏdȂ܂
						//̂ŁAGGO_GRAY4_BITMAP𗘗pĂ܂B
						//
						BYTE byAlpha = (pAlpha[x] << 4) - 1;

						//IuWFNgǗ\z
						OBJECT_STATE_TYPE *pObjState = new OBJECT_STATE_TYPE;
						
						//\IuWFNg𐶐
						pObjState->pObject = new CQubeObjMan();

						//IuWFNg̐Ԃݒ
						pObjState->dwAliveTime[0] = 0;
						pObjState->dwAliveTime[1] = LOGO_SCENE_END_TIME;

						//Jnn_ݒ
						pObjState->StartPos.SetValue((float)(iBaseX + tGlyph.gmptGlyphOrigin.x + x),
													 (float)(iBaseY - ((tTextMet.tmAscent -
											  		 tGlyph.gmptGlyphOrigin.y) + y)),0.0f);
						pObjState->StartPos = pObjState->StartPos * 1.6f;	//Wl̃XP[
							
						//֐̐ݒ
						pObjState->pFunc = (LPOBJECT_FUNC)(CLogoSceneMan::LogoObjFunc);

						//[NGA
						memset(pObjState->abyWork,0,
							sizeof(pObjState->abyWork));
						LOGO_OBJECT_STATE_TYPE *pLogoObjState
						 = (LOGO_OBJECT_STATE_TYPE*)pObjState->abyWork;

						//̃IuWFNg̃lݒ
						pLogoObjState->byAlpha = byAlpha;
						
						//̃IuWFNg̐F(ShbgF)ݒ
						pLogoObjState->fDiffuseR = LOGO_DOT_DIFFUSE_R;
						pLogoObjState->fDiffuseG = LOGO_DOT_DIFFUSE_G;
						pLogoObjState->fDiffuseB = LOGO_DOT_DIFFUSE_B;

						//IuWFNgXgɒǉ
						m_vecObjectList.push_back(pObjState);
					}
				}
				
				//̃C
				pAlpha += iLineBytes;
			}

			//lobt@폜
			delete[] pAlphaBuff;

			//x[XWXV
			iBaseX += iXOffset;
		}

		//̕
		pszLogString = (char*)_mbsinc((BYTE*)pszLogString);
	}
}
//--------------------------------------------------------------------------
void CLogoSceneMan::MatrixSetFunc(CRenderingMan *pRenderingMan,
								  OBJECT_STATE_TYPE *pObjState,DWORD dwNowTime)
{

	//{ϊsݒ菈֐
	
	//V[̎ԂƂɕωϊs(Ⴆ΃JsȂ)ݒ

	//̃IuWFNg̕\Jňoߎ[ms]擾
	float fTime = (float)(dwNowTime - pObjState->dwAliveTime[0]);	

	//wiNA
	if(fTime >= LOGO_BLUR_START_TIME)
		pRenderingMan->ClearWithBlur(0,60);
	else
		pRenderingMan->Clear(0);
	
	//ϊs쐬
	//W͍Wn
	CMatrixMan4 mCamera;
	
	//s
	mCamera.Initialize();
	
	//Ji_jϊs쐬
	CVectorMan3 v1(0.0f,0.0f,-800.0f + (fTime / 10.0f));	//_W
	CVectorMan3 v2(0.0f,0.0f, 0.0f);						//ړ_W
	CVectorMan3 v3(0.0f,1.0f, 0.0f);						//̕
	mCamera.View(v1, v2, v3);								//s쐬
	
	//JϊsZbg
	pRenderingMan->SetCameraMatrix(mCamera);

}
//---------------------------------------------------------------------------
void CLogoSceneMan::LogoObjFunc(CRenderingMan *pRenderingMan,
								OBJECT_STATE_TYPE *pObjState,DWORD dwNowTime)
{

	//S֐

	//̃IuWFNg̕\Jňoߎ[ms]擾
	float fTime = (float)(dwNowTime - pObjState->dwAliveTime[0]);	

	//[NGÃ|C^擾
	LOGO_OBJECT_STATE_TYPE *pLogoState
	 = (LOGO_OBJECT_STATE_TYPE*)pObjState->abyWork;

	//[hϊs쐬
	static float rz = 0.0f;
	CMatrixMan4 m;						//[N
	CMatrixMan4 mWorld;
	m.Scale(1.0f,1.0f,1.5f);			//gs쐬
	mWorld = mWorld * m;				//
	m.Translate(-120.0f + pObjState->StartPos.x,
				  15.0f + pObjState->StartPos.y,
				pObjState->StartPos.z);	//ړs쐬
	mWorld = mWorld * m;				//
	
	m.RotateZ(rz * RAD);
	mWorld = mWorld * m;				//
	m.RotateX(rz * RAD);
	mWorld = mWorld * m;				//
	
	rz += 0.004f;						//̉]pxݒ
	if(rz > 360.0f) rz =0.0f;

	//[hϊsZbg
	pRenderingMan->SetWorldMatrix(mWorld);	

	//ʒuݒ
	pRenderingMan->SetLightVector(DEFAULT_LIGHT_X,
								  DEFAULT_LIGHT_Y,
								  DEFAULT_LIGHT_Z);
	
	//gUݒ
	pRenderingMan->SetDiffuseLight(pLogoState->fDiffuseR,
								   pLogoState->fDiffuseG,
								   pLogoState->fDiffuseB);
	
	//lătF[hCEAEg\
	BYTE byAlpha = pLogoState->byAlpha;
	if(fTime < LOGO_FADEIN_END_TIME)
	{
		float f = fTime / (float)LOGO_FADEIN_END_TIME;
		byAlpha = (BYTE)((float)byAlpha * f * f);
	}
	else if(fTime >= LOGO_FADEOUT_START_TIME)
	{
		float f = 1.0f - (fTime - (float)LOGO_FADEOUT_START_TIME) / 
				  (float)(LOGO_SCENE_END_TIME - LOGO_FADEOUT_START_TIME);
		byAlpha = (BYTE)((float)byAlpha * f * f);
	}
	
	//ŕ`
	pRenderingMan->DrawIndexedPrimitive(pObjState->pObject->GetVertexListPtr(),
									    pObjState->pObject->GetVertexNum(),
										pObjState->pObject->GetPolyIndexListPtr(),
										pObjState->pObject->GetPrimitiveNum(),
										eRT_FLAT,false,byAlpha);
}
//---------------------------------------------------------------------------
void CLogoSceneMan::DrawScene(DWORD dwTime)
{

	//V[̕`
	//DWORD dwTime̓V[Jňoߎ(ms)
		
	//IuWFNgXg`FbNĐĂIuWFNg
	SCENE_OBJECT_VECTOR::iterator ite;
	for(ite  = m_vecObjectList.begin();
		ite != m_vecObjectList.end();++ite)
	{
		//̃IuWFNg͐Ă邩H
		if(((*ite)->dwAliveTime[0] <= dwTime) &&
		   ((*ite)->dwAliveTime[1] >= dwTime))
		{
			//̃IuWFNg̏s
			(*(*ite)->pFunc)(m_pRenderingMan,*ite,dwTime);
		}
	}

#ifdef _DEBUG
	//oߎԕ`
	RGB32_TYPE tColor;
	tColor.R = 255; tColor.G = 255; tColor.B = 255;
	char s[255];
	wsprintf(s,"%d",dwTime);
	m_pRenderingMan->DrawString(10,10,s,tColor);
#endif //_DEBUG

	//V[`
	m_pRenderingMan->Draw3dWorld(TRUE);

	//̃V[̏IԂ߂I
	if(dwTime >= LOGO_SCENE_END_TIME)
	{
		m_bSceneEnd = true;
	}
}
//---------------------------------------------------------------------------



