//---------------------------------------------------------------------------
// Madoka Demo 2006 ܂ǂ̎Ȗ3Df2006  
//
// COpeningSceneMan.h I[vjOSV[}NX
//
//                    ̃V[}NX̓I[vjOSłB
//                    I[vjO"Madoka Presents"̕܂(^^
// 
// Programmed by Mikio Kusaka With Microsoft Visual C++ .Net2003
//
//---------------------------------------------------------------------------
#include "COpeningSceneMan.h"
#include <mbString.h>
#include <math.h>
//---------------------------------------------------------------------------
// 萔 
//---------------------------------------------------------------------------
#define OPENING_SCENE_END_TIME		   (10000)		//̃V[̕\[ms]
#define OPENING_FIRST_MOVE_START_TIME	(4000)		//1Xebvڂ̈ړJn鎞
													//(V[Jňoߎ[ms])
#define OPENING_SECOND_MOVE_START_TIME	(8000)		//2Xebvڂ̈ړJn鎞
													//(V[Jňoߎ[ms])
#define OPENING_FADEIN_END_TIME			(3000)		//tF[hCI
													//(V[Jňoߎ[ms])
#define OPENING_FADEOUT_START_TIME		(8000)		//tF[hAEgJn
													//(V[Jňoߎ[ms])

#define OPENING_FIRST_MOVE_TIME			(600.0f)	//1Xebvڂ̕\ʒuɈړۂ
													//ړ[ms]
#define OPENING_OBJECT_DELAY			(100)		//1Xebvڂ̃IuWFNg
													//nx[ms]
#define OPENING_FLY_PITCH				(4.0f)		//1Xebvڂ̃IuWFNg
													//VU蕝[pixel]
#define OPENING_SECOND_STEP_ACCEL		(0.0003f)	//2Xebvڈړ̈́H
#define OPENING_SECOND_STEP_WEIGHT		(5.0f)		//2Xebvڈړ̑xpEGCg

#define OPENING_BACKOBJ_DIFFUSE_R		(0.0f)		//wiIuWFNg̐F(R)
#define OPENING_BACKOBJ_DIFFUSE_G		(0.5f)		//wiIuWFNg̐F(G)
#define OPENING_BACKOBJ_DIFFUSE_B		(1.0f)		//wiIuWFNg̐F(B)
#define OPENING_FADE_IN_DIFFUSE_R		(1.0f)		//tF[hCF(R)
#define OPENING_FADE_IN_DIFFUSE_G		(1.0f)		//tF[hCF(G)
#define OPENING_FADE_IN_DIFFUSE_B		(1.0f)		//tF[hCF(B)
#define OPENING_FADEOUT_DIFFUSE_R		(1.0f)		//tF[hAEgF(R)
#define OPENING_FADEOUT_DIFFUSE_G		(1.0f)		//tF[hAEgF(G)
#define OPENING_FADEOUT_DIFFUSE_B		(1.0f)		//tF[hAEgF(B)

#define OPENING_BACKOBJ_NUM				(10)		//wiIuWFNg̐

#define OPENING_MY_NAME					"Madoka"	//̖O
#define OPENING_PRESENTS				"Presents"	//Presents

//---------------------------------------------------------------------------
// f[^^萔 
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// \̒` 
//---------------------------------------------------------------------------
//I[vjOV[pIuWFNgړǗp\
//K\̂̃TCYSCENE_OBJECT_WORK_SPACEȉ
//Ȃ悤ɂĂB
#pragma pack(1)
typedef struct tag_Opening_Object_State_Type
{
	int   x,y;			//݈ʒu							8
	UINT  uiChar;		//\							4
	float fV0;			//1Xebvڈړ̏			4
	float fAccel1;		//1Xebvڈړ̉x			4
	float fVecX;		//2XebvڈړXxNg	4
	float fVecY;		//2XebvڈړYxNg	4
	float fAccel2;		//2Xebvڈړ̉x			4

	//ȍ~̓|Sp̎w
	float fDiffuseR;	//gURl						4
	float fDiffuseG;	//gUGl						4
	float fDiffuseB;	//gUBl						4
	
	float fAddAlpha;	//tF[hAEgp|S		4
						//l

	int  iAngle;		//IuWFNg̏p[x]			4

} OPENING_OBJECT_STATE_TYPE;					 //size =  52 
#pragma pack()

//---------------------------------------------------------------------------
// COpeningSceneManNX 
//---------------------------------------------------------------------------
COpeningSceneMan::COpeningSceneMan(CRenderingMan *pRenderingMan)
			     : CSceneManBase(pRenderingMan)
{			

	//RXgN^

	//I[vjOV[}ł͓ɂ邱Ƃ܂

}
//---------------------------------------------------------------------------
COpeningSceneMan::~COpeningSceneMan()
{

	//fXgN^
	
	//I[vjOV[}ł͓ɂ邱Ƃ܂

}
//---------------------------------------------------------------------------
void COpeningSceneMan::CreateScene(void)
{

	//V[IuWFNg̍\z

	//ȑÔ̂폜
	DeleteSceneObject();

	//{ϊsݒIuWFNgǗ쐬
	CreateMatrixSetObjInfo();

	//wip|SIuWFNgǗ쐬
	CreateBackObjInfo();
	
	//IuWFNgǗ쐬
	CreateMojiObjInfo();

	//tF[hCp|SIuWFNgǗ쐬
	CreateFadeInObjInfo();

	//tF[hAEgp|SIuWFNgǗ쐬
	CreateFadeOutObjInfo();


	//V[Jn
	m_bSceneStart = true;
	m_bSceneEnd   = false;
}
//---------------------------------------------------------------------------
void COpeningSceneMan::DeleteScene(void)
{

	//V[IuWFNg̍폜

	DeleteSceneObject();
	m_bSceneStart = false;	
}
//---------------------------------------------------------------------------
void COpeningSceneMan::CreateMatrixSetObjInfo(void)
{

	//{ϊsݒIuWFNgǗ쐬

	//IuWFNgǗ\z
	OBJECT_STATE_TYPE *pMatrixObjState = new OBJECT_STATE_TYPE;
	
	//IuWFNg̐Ԃݒ
	pMatrixObjState->dwAliveTime[0] = 0;
	pMatrixObjState->dwAliveTime[1] = OPENING_SCENE_END_TIME;
	
	//֐̐ݒ
	pMatrixObjState->pFunc = (LPOBJECT_FUNC)(COpeningSceneMan::MatrixSetFunc);

	//IuWFNgXgɒǉ
	m_vecObjectList.push_back(pMatrixObjState);

}
//---------------------------------------------------------------------------
void COpeningSceneMan::CreateBackObjInfo(void)
{

	//wi|SIuWFNgǗ쐬

	int n;
	for(n = 0;n < OPENING_BACKOBJ_NUM;++n)
	{
		//IuWFNgǗ\z
		OBJECT_STATE_TYPE *pBackObjState = new OBJECT_STATE_TYPE;
		
		//IuWFNg̐Ԃݒ
		pBackObjState->dwAliveTime[0] = 0;
		pBackObjState->dwAliveTime[1] = OPENING_SCENE_END_TIME;

		//\3DIuWFNg𐶐
		pBackObjState->pObject = new CQubeObjMan();

		//֐̐ݒ
		pBackObjState->pFunc = (LPOBJECT_FUNC)(COpeningSceneMan::BackObjFunc);

		//[NGA
		memset(pBackObjState->abyWork,0,
				sizeof(pBackObjState->abyWork));
		OPENING_OBJECT_STATE_TYPE *pOpeningObjState
		= (OPENING_OBJECT_STATE_TYPE*)pBackObjState->abyWork;

		//̃|S̐Fݒ
		pOpeningObjState->fDiffuseR = OPENING_BACKOBJ_DIFFUSE_R;
		pOpeningObjState->fDiffuseG = OPENING_BACKOBJ_DIFFUSE_G;
		pOpeningObjState->fDiffuseB = OPENING_BACKOBJ_DIFFUSE_B;

		//IuWFNg̍ŏ̈ʒůpxݒ
		pOpeningObjState->iAngle = (int)(360.0f / (float)OPENING_BACKOBJ_NUM * (float)n);

		//IuWFNgXgɒǉ
		m_vecObjectList.push_back(pBackObjState);
	}
}
//---------------------------------------------------------------------------
void COpeningSceneMan::CreateMojiObjInfo(void)
{

	//IuWFNgǗ쐬
	
	//̖O"Presents"񕪂̃IuWFNg쐬
	//
	// ̃I[vjOV[ł́AOPENING_MY_NAMEOPENING_PRESENTS
	// ԂɉʒɃWv銴ŔэłāA
	// ܂ł΂炭ӂӂ핂AlɔюUȂ
	// ubNAEgĂ̂ݒ肵Ă܂B
	//

	//܂͕ƁAe̕\擾
	int iMyNameMojiCount   = (int)strlen(OPENING_MY_NAME);
	int iPresentsMojiCount = (int)strlen(OPENING_PRESENTS);
	SIZE tMyNameSize       = m_pRenderingMan->GetDrawStringSize(OPENING_MY_NAME);
	SIZE tPresentsSize     = m_pRenderingMan->GetDrawStringSize(OPENING_PRESENTS);
	
	//OPENING_MY_NAMEIuWFNg𐶐AIuWFNgǗ\̂
	//ǉďʒuڕWݒ

	//OPENING_MY_NAME\ʒuZo
	int iMyNameLeft,iMyNameTop;

	iMyNameLeft = (SCREEN_WIDTH  - tMyNameSize.cx) / 2;
	iMyNameTop  = (SCREEN_HEIGHT / 2 - tMyNameSize.cy);

	//OPENING_MY_NAMEIuWFNg̐
	int i;
	int iOffset = 0;
	int iDelay = 0;
	for(i = 0;i < iMyNameMojiCount;++i)
	{
		//IuWFNgǗ\z
		OBJECT_STATE_TYPE *pObjState = new OBJECT_STATE_TYPE;
		
		//IuWFNg̐Ԃݒ
		pObjState->dwAliveTime[0] = OPENING_FIRST_MOVE_START_TIME +
									iDelay * OPENING_OBJECT_DELAY;
		pObjState->dwAliveTime[1] = OPENING_SCENE_END_TIME;

		//ړJnn_ƖڕWn_ݒ
		pObjState->StartPos.SetValue ((float)(iMyNameLeft + iOffset),
								      (float)(SCREEN_HEIGHT),0.0f);
		pObjState->TargetPos.SetValue((float)(iMyNameLeft + iOffset),
								      (float)(iMyNameTop),0.0f);
		
		//֐̐ݒ
		pObjState->pFunc = (LPOBJECT_FUNC)(COpeningSceneMan::MojiObjFunc);

		//[NGA
		memset(pObjState->abyWork,0,
			   sizeof(pObjState->abyWork));
		OPENING_OBJECT_STATE_TYPE *pOpeningObjState
		 = (OPENING_OBJECT_STATE_TYPE*)pObjState->abyWork;

		pOpeningObjState->x       = (int)pObjState->StartPos.x;
		pOpeningObjState->y       = (int)pObjState->StartPos.y;
		pOpeningObjState->uiChar  = _mbsnextc((const unsigned char*)
											 (OPENING_MY_NAME) + i);
		pOpeningObjState->fAccel1 = (pObjState->TargetPos.y - pObjState->StartPos.y) /
								    (OPENING_FIRST_MOVE_TIME * 
								     (OPENING_FIRST_MOVE_TIME - 1) /
								 	 2.0f);
		pOpeningObjState->fV0     = pOpeningObjState->fAccel1 *
								    OPENING_FIRST_MOVE_TIME;
		//
		//OPENING_FIRST_MOVE_TIMEԌɂ傤ǖړIʒuɃJbgC
		//悤ɏƉx()ZoB
		//̈ʒu
		//
		//  y(T) = StartPos.y + fV0*T - 0.5*fAccel*T^2
		//
		//ŌvZ܂BT͈ړJňoߎ(ms)AT^2T2łB
		//
		//̈ړ͐ɐ^iނȂ̂ŁAyvZ܂B
		//
		//x̌vẐƂ͈ȉ̃TCg̎𗘗pĒ܂B
		//http://d.hatena.ne.jp/kenmo/20051211#p1
		//肪Ƃ܂B
		//
		float fAngle = (float)(rand() % 360) * RAD;		//ړpx_Ɍ
		CVectorMan3 Vec(cos(fAngle),sin(fAngle),0.0f);	//ړxNg̍쐬
		Vec.Normalize();								//PʃxNg
		pOpeningObjState->fVecX   = Vec.x / OPENING_SECOND_STEP_WEIGHT;
		pOpeningObjState->fVecY   = Vec.y / OPENING_SECOND_STEP_WEIGHT;
		pOpeningObjState->fAccel2 = OPENING_SECOND_STEP_ACCEL;
		//
		//ł́A^񒆂łӂӂ핂AlɔюU镔
		//ړxNgƁA炩̈(?)ɂĈ铮o
		//ׂ̉xݒ肵Ă܂B
	

		//\ʒuItZbg(ɂ炷l)XV
		iOffset += m_pRenderingMan->GetDrawMojiWidth(pOpeningObjState->uiChar);

		//IuWFNgXgɒǉ
		m_vecObjectList.push_back(pObjState);

		//IuWFNgxJE^XV
		iDelay++;
	}


	//OPENING_PRESENTSIuWFNg𐶐AIuWFNgǗ\̂
	//ǉďʒuڕWݒ

	//OPENING_PRESENTS\ʒuZo
	int iPresentsLeft,iPresentsTop;

	iPresentsLeft = (SCREEN_WIDTH  - tPresentsSize.cx) / 2;
	iPresentsTop  = (SCREEN_HEIGHT / 2 + 2);

	//OPENING_PRESENTSIuWFNg̐
	iOffset = 0;
	for(i = 0;i < iPresentsMojiCount;++i)
	{
		//IuWFNgǗ\z
		OBJECT_STATE_TYPE *pObjState = new OBJECT_STATE_TYPE;
		
		//IuWFNg̐Ԃݒ
		pObjState->dwAliveTime[0] = OPENING_FIRST_MOVE_START_TIME +
									iDelay * OPENING_OBJECT_DELAY;
		pObjState->dwAliveTime[1] = OPENING_SCENE_END_TIME;

		//ړJnn_ƖڕWn_ݒ
		pObjState->StartPos.SetValue ((float)(iPresentsLeft + iOffset),
								      (float)(SCREEN_HEIGHT),0.0f);
		pObjState->TargetPos.SetValue((float)(iPresentsLeft + iOffset),
								      (float)(iPresentsTop),0.0f);
		
		//֐̐ݒ
		pObjState->pFunc = (LPOBJECT_FUNC)(COpeningSceneMan::MojiObjFunc);

		//[NGA
		memset(pObjState->abyWork,0,
			   sizeof(pObjState->abyWork));
		OPENING_OBJECT_STATE_TYPE *pOpeningObjState
		 = (OPENING_OBJECT_STATE_TYPE*)pObjState->abyWork;

		pOpeningObjState->x       = (int)pObjState->StartPos.x;
		pOpeningObjState->y       = (int)pObjState->StartPos.y;
		pOpeningObjState->uiChar  = _mbsnextc((const unsigned char*)
									(OPENING_PRESENTS) + i);
		pOpeningObjState->fAccel1 = (pObjState->TargetPos.y - pObjState->StartPos.y) /
								    (OPENING_FIRST_MOVE_TIME * 
								     (OPENING_FIRST_MOVE_TIME - 1) /
									 2.0f);
		pOpeningObjState->fV0     = pOpeningObjState->fAccel1 *
								    OPENING_FIRST_MOVE_TIME;
		//
		//OPENING_FIRST_MOVE_TIMEԌɂ傤ǖړIʒuɃJbgC
		//悤ɏƉx()ZoB
		//̈ʒu
		//
		//  y(T) = StartPos.y + fV0*T - 0.5*fAccel*T^2
		//
		//ŌvZ܂BT͈ړJňoߎ(ms)AT^2T2łB
		//
		//̈ړ͐ɐ^iނȂ̂ŁAyvZ܂B
		//
		//x̌vẐƂ͈ȉ̃TCg̎𗘗pĒ܂B
		//http://d.hatena.ne.jp/kenmo/20051211#p1
		//肪Ƃ܂B
		//
		float fAngle = (float)(rand() % 360) * RAD;		//ړpx_Ɍ						       
		CVectorMan3 Vec(cos(fAngle),sin(fAngle),0.0f);	//ړxNg̍쐬
		Vec.Normalize();								//PʃxNg
		pOpeningObjState->fVecX   = Vec.x / OPENING_SECOND_STEP_WEIGHT;
		pOpeningObjState->fVecY   = Vec.y / OPENING_SECOND_STEP_WEIGHT;
		pOpeningObjState->fAccel2 = OPENING_SECOND_STEP_ACCEL;
		//
		//ł́A^񒆂łӂӂ핂AlɔюU镔
		//ړxNgƁA炩̈(?)ɂĈ铮o
		//ׂ̉xݒ肵Ă܂B
	

		//\ʒuItZbg(ɂ炷l)XV
		iOffset += m_pRenderingMan->GetDrawMojiWidth(pOpeningObjState->uiChar);

		//IuWFNgXgɒǉ
		m_vecObjectList.push_back(pObjState);

		//IuWFNgxJE^XV
		iDelay++;
	}
}
//---------------------------------------------------------------------------
void COpeningSceneMan::CreateFadeInObjInfo(void)
{

	//tF[hCp|SIuWFNgǗ쐬

	//IuWFNgǗ\z
	OBJECT_STATE_TYPE *pFadeInObjState = new OBJECT_STATE_TYPE;
	
	//IuWFNg̐Ԃݒ
	pFadeInObjState->dwAliveTime[0] = 0;
	pFadeInObjState->dwAliveTime[1] = OPENING_FADEIN_END_TIME;

	//|SIuWFNg̐
	pFadeInObjState->pObject = new CSquareXYObjMan();

	//֐̐ݒ
	pFadeInObjState->pFunc = (LPOBJECT_FUNC)(COpeningSceneMan::FadeInObjFunc);

	//[NGA
	memset(pFadeInObjState->abyWork,0,
			sizeof(pFadeInObjState->abyWork));
	OPENING_OBJECT_STATE_TYPE * pOpeningObjState
	 = (OPENING_OBJECT_STATE_TYPE*)pFadeInObjState->abyWork;

	//̃|S̐F(tF[hCF)ݒ
	pOpeningObjState->fDiffuseR = OPENING_FADE_IN_DIFFUSE_R;
	pOpeningObjState->fDiffuseG = OPENING_FADE_IN_DIFFUSE_G;
	pOpeningObjState->fDiffuseB = OPENING_FADE_IN_DIFFUSE_B;

	//tF[hCۂ̃l̎ԒPʂ̌lvZ
	pOpeningObjState->fAddAlpha
	 = -255.0f / (float)(pFadeInObjState->dwAliveTime[1] - 
						 pFadeInObjState->dwAliveTime[0]);				

	//IuWFNgXgɒǉ
	m_vecObjectList.push_back(pFadeInObjState);

}
//---------------------------------------------------------------------------
void COpeningSceneMan::CreateFadeOutObjInfo(void)
{

	//tF[hAEgp|SIuWFNgǗ쐬

	//IuWFNgǗ\z
	OBJECT_STATE_TYPE *pFadeOutObjState = new OBJECT_STATE_TYPE;
	
	//IuWFNg̐Ԃݒ
	pFadeOutObjState->dwAliveTime[0] = OPENING_FADEOUT_START_TIME;
	pFadeOutObjState->dwAliveTime[1] = OPENING_SCENE_END_TIME;

	//|SIuWFNg̐
	pFadeOutObjState->pObject = new CSquareXYObjMan();

	//֐̐ݒ
	pFadeOutObjState->pFunc = (LPOBJECT_FUNC)(COpeningSceneMan::FadeOutObjFunc);

	//[NGA
	memset(pFadeOutObjState->abyWork,0,
			sizeof(pFadeOutObjState->abyWork));
	OPENING_OBJECT_STATE_TYPE * pOpeningObjState
	 = (OPENING_OBJECT_STATE_TYPE*)pFadeOutObjState->abyWork;

	//̃|S̐F(tF[hAEgF)ݒ
	pOpeningObjState->fDiffuseR = OPENING_FADEOUT_DIFFUSE_R;
	pOpeningObjState->fDiffuseG = OPENING_FADEOUT_DIFFUSE_G;
	pOpeningObjState->fDiffuseB = OPENING_FADEOUT_DIFFUSE_B;

	//tF[hAEgۂ̃l̎ԒPʂ̑lvZ
	pOpeningObjState->fAddAlpha
	 = 255.0f / (float)(pFadeOutObjState->dwAliveTime[1] - 
						pFadeOutObjState->dwAliveTime[0]);				

	//IuWFNgXgɒǉ
	m_vecObjectList.push_back(pFadeOutObjState);

}
//---------------------------------------------------------------------------
void COpeningSceneMan::MatrixSetFunc(CRenderingMan *pRenderingMan,
									 OBJECT_STATE_TYPE *pObjState,DWORD dwNowTime)
{

	//{ϊsݒ菈֐
	
	//V[̎ԂƂɕωϊs(Ⴆ΃JsȂ)ݒ

	//ϊs쐬
	//W͍Wn
	CMatrixMan4 mCamera;
	CMatrixMan4 mProjection;
	
	//s
	mCamera.Initialize();
	mProjection.Initialize();

	//Ji_jϊs쐬
	CVectorMan3 v1(0.0f,0.0f,-1.0f);	//_W
	CVectorMan3 v2(0.0f,0.0f, 0.0f);	//ړ_W
	CVectorMan3 v3(0.0f,1.0f, 0.0f);	//̕
	mCamera.View(v1, v2, v3);			//s쐬
	
	//JϊsZbg
	pRenderingMan->SetCameraMatrix(mCamera);


	//ˉeϊs쐬
	//ŋߓ_Eŉ_EpEpc̏Őݒ
	mProjection.Projection2(0.0f,1000.0f,		//ZlL͈͂Min,Max
							60.0f * RAD,		//p
							60.0f * RAD);		//pc
	
	//ˉeϊsZbg
	pRenderingMan->SetProjectionMatrix(mProjection);

	//r[|[gݒ
	pRenderingMan->SetViewPort(0.0f,0.0f,(float)SCREEN_WIDTH,(float)SCREEN_HEIGHT);


}
//---------------------------------------------------------------------------
void COpeningSceneMan::BackObjFunc(CRenderingMan *pRenderingMan,
								   OBJECT_STATE_TYPE *pObjState,DWORD dwNowTime)
{

	//wi|SIuWFNg֐
	//
	// deNowTime = V[Jňoߎ[ms]
	//

	//̃IuWFNg̕\Jňoߎ[ms]擾
	float fTime = (float)(dwNowTime - pObjState->dwAliveTime[0]);	

	//[NGÃ|C^擾
	OPENING_OBJECT_STATE_TYPE *pOpeningState
	 = (OPENING_OBJECT_STATE_TYPE*)pObjState->abyWork;

	//傫ȉ~̒S̋sinJ[uŕ\
	//  / 8 ͑xp
	// 5.0f ͐Lk̂ӂ蕝
	DWORD dwTime = (dwNowTime - pObjState->dwAliveTime[0]);
	float fRadius = 5.0f * sin(((float)((dwTime / 8) % 360) * RAD));
	 
	//IuWFNgSɉ]pxZo
	float fObjRY = (float)((dwTime / 4) % 360) * RAD;

	//[hϊs쐬
	CMatrixMan4 m;								//[N
	CMatrixMan4 mWorld;

	m.Scale(1.0f,1.0f,1.0f);					//IuWFNĝ̂̊g
	mWorld = mWorld * m;						//
	m.RotateY(fObjRY);							//IuWFNg_ŉ]
	mWorld = mWorld * m;						//	
	
	m.Translate(fRadius,0.0f,0.0f);				//OɈړ
	mWorld = mWorld * m;						//
	
	int iAngle = pOpeningState->iAngle +
				 (int)(fTime / 1000.0f * 60.0f);
	m.RotateY((float)(iAngle % 360) * RAD);		//傫ȉ~ŉ悤
	mWorld = mWorld * m;						//	
	m.RotateX(-30.0f * RAD);					//ƎOɌX
	mWorld = mWorld * m;						//	
	m.Translate(0.0f,0.0f,10.0f);				//S̓IɉɈړ
	mWorld = mWorld * m;						//


	//[hϊsZbg
	pRenderingMan->SetWorldMatrix(mWorld);	

	//ʒuݒ
	pRenderingMan->SetLightVector(DEFAULT_LIGHT_X,
								  DEFAULT_LIGHT_Y,
								  DEFAULT_LIGHT_Z);
	
	//gUݒ
	pRenderingMan->SetDiffuseLight(pOpeningState->fDiffuseR,
								   pOpeningState->fDiffuseG,
								   pOpeningState->fDiffuseB);

	//`
	pRenderingMan->DrawIndexedPrimitive(pObjState->pObject->GetVertexListPtr(),
									    pObjState->pObject->GetVertexNum(),
										pObjState->pObject->GetPolyIndexListPtr(),
										pObjState->pObject->GetPrimitiveNum(),
										eRT_FLAT);

}
//---------------------------------------------------------------------------
void COpeningSceneMan::MojiObjFunc(CRenderingMan *pRenderingMan,
								   OBJECT_STATE_TYPE *pObjState,DWORD dwNowTime)
{

	//IuWFNg֐
	//
	// deNowTime = V[Jňoߎ[ms]
	//

	int x,y;
	
	//̃IuWFNg̕\Jňoߎ[ms]擾
	float fTime = (float)(dwNowTime - pObjState->dwAliveTime[0]);	

	//[NGÃ|C^擾
	OPENING_OBJECT_STATE_TYPE *pOpeningState
	 = (OPENING_OBJECT_STATE_TYPE*)pObjState->abyWork;

	if(dwNowTime >= OPENING_SECOND_MOVE_START_TIME)
	{
		//2Xebvڂ̈ړ
		
		//_ȕɔюU܂
		float fTime  = (float)(dwNowTime - OPENING_SECOND_MOVE_START_TIME);
		float fSignX = (pOpeningState->fVecX > 0.0f) ? -1.0f : 1.0f;
		float fSignY = (pOpeningState->fVecY > 0.0f) ? -1.0f : 1.0f;
		x = (int)(pOpeningState->x + 
				  pOpeningState->fVecX * fTime + 
				  fSignX * 0.5f * pOpeningState->fAccel2 * fTime * fTime +
				  0.5f);
		y = (int)(pOpeningState->y + 
				  pOpeningState->fVecY * fTime + 
				  fSignY * 0.5f * pOpeningState->fAccel2 * fTime * fTime + 
				  0.5f);
		//\KȌvZłA_ȕɐi݂Aił
		//Ƃ͋t̕ɉxIɈ(?)Aӂ[ƉĂǂ
		//Ă̓ɂĂ݂܂(^-^;

	}
	else if(fTime >= OPENING_FIRST_MOVE_TIME)
	{
		//ŏ̈ړŖړIʒuɓ

		//ړIʒuɒӂӂ핂Ă
		DWORD dwAngle = ((DWORD)(fTime - OPENING_FIRST_MOVE_TIME) / 2) % 360;	
                                                              // /2͑x
		float fAngle  = (float)dwAngle * RAD;

        x = (int)pObjState->TargetPos.x;
		y = (int)(pObjState->TargetPos.y + 
				  OPENING_FLY_PITCH * sin(fAngle) + 0.5f);

		//݈ʒu[NGAɕۑ
		pOpeningState->x = x;
		pOpeningState->y = y;
	}
	else
	{
		//1Xebvڂ̈ړ

		//x^ňړ
		//|[ĕ蓊銴œ܂
		x = (int)pObjState->TargetPos.x;
		y = (int)(pObjState->StartPos.y +
				  pOpeningState->fV0 * fTime - 
				  0.5f * pOpeningState->fAccel1 *
				  fTime * fTime + 0.5f);
	}

	//ẅʒuɕ\
	RGB32_TYPE tColor;
	tColor.R = 255; tColor.G = 255; tColor.B = 255;
	
	pRenderingMan->DrawMoji(x,y,pOpeningState->uiChar,tColor);	
	
}
//---------------------------------------------------------------------------
void COpeningSceneMan::FadeInObjFunc(CRenderingMan *pRenderingMan,
									 OBJECT_STATE_TYPE *pObjState,DWORD dwNowTime)
{

	//tF[hCp|SIuWFNg֐
	//
	// deNowTime = V[Jňoߎ[ms]
	//

	//̃IuWFNg̕\Jňoߎ[ms]擾
	float fTime = (float)(dwNowTime - pObjState->dwAliveTime[0]);	

	//[NGÃ|C^擾
	OPENING_OBJECT_STATE_TYPE *pOpeningState
	 = (OPENING_OBJECT_STATE_TYPE*)pObjState->abyWork;


	//[hϊs쐬
	CMatrixMan4 m;						//[N
	CMatrixMan4 mWorld;
	m.Scale(1.5f,1.5f,1.0f);			//gs쐬
	mWorld = mWorld * m;				//
	m.Translate(0.0f,0.0f,0.0f);		//ړs쐬
	mWorld = mWorld * m;				//
	
	//[hϊsZbg
	pRenderingMan->SetWorldMatrix(mWorld);	

	//ʒuݒ
	//pRenderingMan->SetLightVector(0.0f,0.0f,1.0f);
	pRenderingMan->SetLightVector(0.0f,0.0f,0.0f);	//ubNCꍇ

	//gUݒ
	pRenderingMan->SetDiffuseLight(pOpeningState->fDiffuseR,
								   pOpeningState->fDiffuseG,
								   pOpeningState->fDiffuseB);

	//݂̃lvZ
	float fAlpha = 255.0f + pOpeningState->fAddAlpha * fTime;
	if(fAlpha < 0.0f) fAlpha = 0.0f;
	
	//ŕ`
	pRenderingMan->DrawIndexedPrimitive(pObjState->pObject->GetVertexListPtr(),
									    pObjState->pObject->GetVertexNum(),
										pObjState->pObject->GetPolyIndexListPtr(),
										pObjState->pObject->GetPrimitiveNum(),
										eRT_FLAT,false,(BYTE)fAlpha);

}
//---------------------------------------------------------------------------
void COpeningSceneMan::FadeOutObjFunc(CRenderingMan *pRenderingMan,
									  OBJECT_STATE_TYPE *pObjState,DWORD dwNowTime)
{

	//tF[hAEgp|SIuWFNg֐
	//
	// deNowTime = V[Jňoߎ[ms]
	//

	//̃IuWFNg̕\Jňoߎ[ms]擾
	float fTime = (float)(dwNowTime - pObjState->dwAliveTime[0]);	

	//[NGÃ|C^擾
	OPENING_OBJECT_STATE_TYPE *pOpeningState
	 = (OPENING_OBJECT_STATE_TYPE*)pObjState->abyWork;


	//[hϊs쐬
	CMatrixMan4 m;						//[N
	CMatrixMan4 mWorld;
	m.Scale(1.5f,1.5f,1.0f);			//gs쐬
	mWorld = mWorld * m;				//
	m.Translate(0.0f,0.0f,0.0f);		//ړs쐬
	mWorld = mWorld * m;				//
	
	//[hϊsZbg
	pRenderingMan->SetWorldMatrix(mWorld);	

	//ʒuݒ
	//pRenderingMan->SetLightVector(0.0f,0.0f,1.0f);
	pRenderingMan->SetLightVector(0.0f,0.0f,0.0f);	//ubNAEgꍇ

	//gUݒ
	pRenderingMan->SetDiffuseLight(pOpeningState->fDiffuseR,
								   pOpeningState->fDiffuseG,
								   pOpeningState->fDiffuseB);

	//݂̃lvZ
	float fAlpha = pOpeningState->fAddAlpha * fTime;
	if(fAlpha > 255.0f) fAlpha = 255.0f;
	
	//ŕ`
	pRenderingMan->DrawIndexedPrimitive(pObjState->pObject->GetVertexListPtr(),
									    pObjState->pObject->GetVertexNum(),
										pObjState->pObject->GetPolyIndexListPtr(),
										pObjState->pObject->GetPrimitiveNum(),
										eRT_FLAT,false,(BYTE)fAlpha);

}
//---------------------------------------------------------------------------
void COpeningSceneMan::DrawScene(DWORD dwTime)
{

	//V[̕`
	//DWORD dwTime̓V[Jňoߎ(ms)
	
	//wiNA
	m_pRenderingMan->Clear(0);
	
	//IuWFNgXg`FbNĐĂIuWFNg
	SCENE_OBJECT_VECTOR::iterator ite;
	for(ite  = m_vecObjectList.begin();
		ite != m_vecObjectList.end();++ite)
	{
		//̃IuWFNg͐Ă邩H
		if(((*ite)->dwAliveTime[0] <= dwTime) &&
		   ((*ite)->dwAliveTime[1] >= dwTime))
		{
			//̃IuWFNg̏s
			(*(*ite)->pFunc)(m_pRenderingMan,*ite,dwTime);
		}
	}

#ifdef _DEBUG
	//oߎԕ`
	RGB32_TYPE tColor;
	tColor.R = 255; tColor.G = 255; tColor.B = 255;
	char s[255];
	wsprintf(s,"%d",dwTime);
	m_pRenderingMan->DrawString(10,10,s,tColor);
#endif //_DEBUG

	//V[`
	m_pRenderingMan->Draw3dWorld(TRUE);

	//̃V[̏IԂ߂I
	if(dwTime >= OPENING_SCENE_END_TIME)
	{
		m_bSceneEnd = true;
	}
}
//---------------------------------------------------------------------------




//ȉ̃eXgV[}͂܂ŉ̂̂Ȃ̂ŁAI[vjOV[}NX
//t@CɊ񐶂ĂĂ܂(^^:

#include "screen.h"
#include <mbstring.h>

typedef enum 
{
	eOBJ_QUBE = 0,
	eOBJ_TORUS,
	eOBJ_SQUARE_XY,
	eOBJ_SQUARE_XZ,

	eOBJ_NUM,
} OBJ_3D_ENUM;

//HSL2RGBp}N
#define H2V(Value,h) {\
	if(h >  360.0f) h -= 360.0f;\
	if(h <    0.0f) h += 360.0f;\
	if(h <   60.0f) Value = (unsigned char)((cmin + (cmax - cmin) * h / 60.0f) * 255.0f);\
	if(h >=  60.0f && h < 180.0f) Value = (unsigned char)(cmax * 255.0f);\
	if(h >= 180.0f && h < 240.0f) Value = (unsigned char)((cmin + (cmax - cmin) * (240.0f - h) / 60.0f) * 255.0f);\
	if(h >= 240.0f) Value = (unsigned char)(cmin * 255.0f);\
}

void HSL2RGB(float fH,float fS,float fL,RGB32_TYPE *pRGB)
{

	//HSLFԂRGBFԂɕϊ
	float h,s,l,cmax,cmin;

	h = fH;				//Hue       :F(0`359)
	s = fS / 100.0f;	//Suturation:ʓx(0`100)
	l = fL / 100.0f;	//Luminance :Px(0`100)

	if(l <= 0.5)
	{
		cmin = l * (1.0f - s);
		cmax = 2.0f * l - cmin;
	}
	else
	{
		cmax = l * (1.0f - s) + s;
		cmin = 2.0f * l - cmax;
	}

	H2V(pRGB->G,h);
	h += 120.0f;
	H2V(pRGB->R,h);
	h -= 240.0f;
	H2V(pRGB->B,h);
}

void CTestSceneMan::CreateScene(void)
{
	//V[IuWFNg̍\z

	//ȑÔ̂폜
	DeleteSceneObject();

	//ԂɃXgɒǉ
	CQubeObjMan     *pQubeObj     = NULL;			//L[uIuWFNg
	CTorusObjMan    *pTorusObj    = NULL;			//g[XIuWFNg
	CSquareXYObjMan *pSquareXYObj = NULL;			//lp`(X-Y)IuWFNg
	CSquareXZObjMan *pSquareXZObj = NULL;			//lp`(X-Z)IuWFNg

	OBJECT_STATE_TYPE *pQube = new OBJECT_STATE_TYPE;
	pQube->pObject = new CQubeObjMan();
	m_vecObjectList.push_back(pQube);

	OBJECT_STATE_TYPE *pTorus = new OBJECT_STATE_TYPE;
	pTorus->pObject = new CTorusObjMan(10);
	m_vecObjectList.push_back(pTorus);

	OBJECT_STATE_TYPE *pSquareXY = new OBJECT_STATE_TYPE;
	pSquareXY->pObject = new CSquareXYObjMan();
	m_vecObjectList.push_back(pSquareXY);

	OBJECT_STATE_TYPE *pSquareXZ = new OBJECT_STATE_TYPE;
	pSquareXZ->pObject = new CSquareXZObjMan();
	m_vecObjectList.push_back(pSquareXZ);

	//V[Jn
	m_bSceneStart = true;
	m_bSceneEnd   = false;
}

void CTestSceneMan::DeleteScene(void)
{
	//V[IuWFNg̍폜
	DeleteSceneObject();
	m_bSceneStart = false;	
}

void CTestSceneMan::DrawScene(DWORD dwTime)
{
	//V[̕`
	//DWORD dwTime̓V[Jňoߎ(ms)


	//wi
	//m_pRenderingMan->Clear(SCREEN_COLOR);
	m_pRenderingMan->ClearWithBlur(SCREEN_COLOR,50,false);

	//ϊs쐬
	//W͍Wn
	static float ry = 0;
	CMatrixMan4 mWorld;
	CMatrixMan4 mView;
	CMatrixMan4 mProjection;
	CMatrixMan4 m;

	//s
	mWorld.Initialize();
	mView.Initialize();
	mProjection.Initialize();

	//Ji_jϊs쐬
	CVectorMan3 v1(0.0f,0.0f,-10.0f);	//_W
	CVectorMan3 v2(0.0f,0.0f,  0.0f);	//ړ_W
	CVectorMan3 v3(0.0f,1.0f,  0.0f);	//̕
	m.View(v1, v2, v3);					//s쐬
	mView = m;

	//JϊsZbg
	m_pRenderingMan->SetCameraMatrix(mView);

	//ˉeϊs쐬
	//ŋߓ_Eŉ_EpEpc̏Őݒ
	m.Projection2(0.0f,1000.0f,60.0f * RAD,60.0f * RAD);
	mProjection = m;

	//ˉeϊsZbg
	m_pRenderingMan->SetProjectionMatrix(mProjection);

	//r[|[gݒ
	m_pRenderingMan->SetViewPort(0.0f,0.0f,(float)SCREEN_WIDTH,(float)SCREEN_HEIGHT);

	//ʒuݒ
	m_pRenderingMan->SetLightVector(DEFAULT_LIGHT_X,
								    DEFAULT_LIGHT_Y,
								    DEFAULT_LIGHT_Z);
	
#if 1	//gUωꍇ́1ɂ

	//gUݒ
	RGB32_TYPE tColor;
	HSL2RGB(ry,100.0f,50.0f,&tColor);
	m_pRenderingMan->SetDiffuseLight((float)tColor.R / 255.0f,
									 (float)tColor.G / 255.0f,
									 (float)tColor.B / 255.0f);	
#endif 

C3dObjectManBase *pObject;

#if 1 //L[u (g[XłɕύXꍇ́10)

	//IuWFNg4zu
	float fScale  = 15.0f;
	float fOffset = 15.0f; 
	float fZ      = 50.0f;

	//[hϊs쐬
	m.Scale(fScale,fScale,fScale);		//gs쐬
	mWorld = m;				
//	m.RotateY(ry * RAD);				//x]s쐬	
//	mWorld = mWorld * m;
//	m.RotateX(ry * RAD);				//w]s쐬
//	mWorld = mWorld * m;
	m.RotateZ(ry * RAD);				//y]s쐬
	mWorld = mWorld * m;
	m.Translate(-fOffset,-fOffset,fZ);	//ֈړ
	mWorld = mWorld * m;
	
	m.RotateZ(ry * RAD);				//y]s쐬
	mWorld = mWorld * m;
	
	//[hϊsZbg
	m_pRenderingMan->SetWorldMatrix(mWorld);	

	//_O
	pObject = m_vecObjectList[eOBJ_QUBE]->pObject;
	m_pRenderingMan->DrawIndexedPrimitive(pObject->GetVertexListPtr(),
										  pObject->GetVertexNum(),
									      pObject->GetPolyIndexListPtr(),
										  pObject->GetPrimitiveNum(),
									      eRT_FLAT,true);


	//2ڂ̃IuWFNg`

	//[hϊs쐬
	m.Scale(fScale,fScale,fScale);		//gs쐬
	mWorld = m;				
//	m.RotateY(ry * RAD);				//x]s쐬	
//	mWorld = mWorld * m;
	m.RotateX(ry * RAD);				//w]s쐬
	mWorld = mWorld * m;
//	m.RotateZ(ry * RAD);				//y]s쐬
//	mWorld = mWorld * m;
	m.Translate(-fOffset,fOffset,fZ);	//ֈړ
	mWorld = mWorld * m;

	m.RotateZ(ry * RAD);				//y]s쐬
	mWorld = mWorld * m;
	
	//[hϊsZbg
	m_pRenderingMan->SetWorldMatrix(mWorld);

	//_O
	pObject = m_vecObjectList[eOBJ_QUBE]->pObject;
	m_pRenderingMan->DrawIndexedPrimitive(pObject->GetVertexListPtr(),
										  pObject->GetVertexNum(),
										  pObject->GetPolyIndexListPtr(),
										  pObject->GetPrimitiveNum(),
										  eRT_FLAT);

	//3ڂ̃IuWFNg`

	//[hϊs쐬
	m.Scale(fScale,fScale,fScale);		//gs쐬
	mWorld = m;				
	m.RotateY(ry * RAD);				//x]s쐬	
	mWorld = mWorld * m;
//	m.RotateX(ry * RAD);				//w]s쐬
//	mWorld = mWorld * m;
//	m.RotateZ(ry * RAD);				//y]s쐬
//	mWorld = mWorld * m;
	m.Translate(fOffset,fOffset,fZ);	//ֈړ
	mWorld = mWorld * m;
	
	m.RotateZ(ry * RAD);				//y]s쐬
	mWorld = mWorld * m;
	
	//[hϊsZbg
	m_pRenderingMan->SetWorldMatrix(mWorld);

	//_O
	pObject = m_vecObjectList[eOBJ_QUBE]->pObject;
	m_pRenderingMan->DrawIndexedPrimitive(pObject->GetVertexListPtr(),
										  pObject->GetVertexNum(),
										  pObject->GetPolyIndexListPtr(),
										  pObject->GetPrimitiveNum(),
										  eRT_FLAT);

	//4ڂ̃IuWFNg`

	//[hϊs쐬
	m.Scale(fScale,fScale,fScale);		//gs쐬
	mWorld = m;				
	m.RotateY(ry * RAD);				//x]s쐬	
	mWorld = mWorld * m;
	m.RotateX(ry * RAD);				//w]s쐬
	mWorld = mWorld * m;
	m.RotateZ(ry * RAD);				//y]s쐬
	mWorld = mWorld * m;
	m.Translate(fOffset,-fOffset,fZ);	//ֈړ
	mWorld = mWorld * m;
	
	m.RotateZ(ry * RAD);				//y]s쐬
	mWorld = mWorld * m;
	
	//[hϊsZbg
	m_pRenderingMan->SetWorldMatrix(mWorld);

	//_O
	pObject = m_vecObjectList[eOBJ_QUBE]->pObject;
	m_pRenderingMan->DrawIndexedPrimitive(pObject->GetVertexListPtr(),
										  pObject->GetVertexNum(),
										  pObject->GetPolyIndexListPtr(),
										  pObject->GetPrimitiveNum(),
										  eRT_FLAT);

#else

	//IuWFNg4zu
	float fScale  = 20.0f;
	float fOffset = 30.0f; 
	float fZ      = 100.0f;

	//[hϊs쐬
	m.Scale(fScale,fScale,fScale);		//gs쐬
	mWorld = m;				
//	m.RotateY(ry * RAD);				//x]s쐬	
//	mWorld = mWorld * m;
//	m.RotateX(ry * RAD);				//w]s쐬
//	mWorld = mWorld * m;
	m.RotateZ(ry * RAD);				//y]s쐬
	mWorld = mWorld * m;
	m.Translate(-fOffset,-fOffset,fZ);	//ֈړ
	mWorld = mWorld * m;
	
	//[hϊsZbg
	m_pRenderingMan->SetWorldMatrix(mWorld);	

	//_O
	pObject = m_vecObjectList[eOBJ_TORUS]->pObject;
	m_pRenderingMan->DrawIndexedPrimitive(pObject->GetVertexListPtr(),
										  pObject->GetVertexNum(),
										  pObject->GetPolyIndexListPtr(),
										  pObject->GetPrimitiveNum(),
										  eRT_FLAT);


	//2ڂ̃IuWFNg`

	//[hϊs쐬
	m.Scale(fScale,fScale,fScale);		//gs쐬
	mWorld = m;				
//	m.RotateY(ry * RAD);				//x]s쐬	
//	mWorld = mWorld * m;
	m.RotateX(ry * RAD);				//w]s쐬
	mWorld = mWorld * m;
//	m.RotateZ(ry * RAD);				//y]s쐬
//	mWorld = mWorld * m;
	m.Translate(-fOffset,fOffset,fZ);	//ֈړ
	mWorld = mWorld * m;
	
	//[hϊsZbg
	m_pRenderingMan->SetWorldMatrix(mWorld);

	//_O
	pObject = m_vecObjectList[eOBJ_TORUS]->pObject;
	m_pRenderingMan->DrawIndexedPrimitive(pObject->GetVertexListPtr(),
										  pObject->GetVertexNum(),
										  pObject->GetPolyIndexListPtr(),
										  pObject->GetPrimitiveNum(),
										  eRT_WIRE);

	//3ڂ̃IuWFNg`

	//[hϊs쐬
	m.Scale(fScale,fScale,fScale);		//gs쐬
	mWorld = m;				
	m.RotateY(ry * RAD);				//x]s쐬	
	mWorld = mWorld * m;
//	m.RotateX(ry * RAD);				//w]s쐬
//	mWorld = mWorld * m;
//	m.RotateZ(ry * RAD);				//y]s쐬
//	mWorld = mWorld * m;
	m.Translate(fOffset,fOffset,fZ);	//ֈړ
	mWorld = mWorld * m;
	
	//[hϊsZbg
	m_pRenderingMan->SetWorldMatrix(mWorld);

	//_O
	pObject = m_vecObjectList[eOBJ_TORUS]->pObject;
	m_pRenderingMan->DrawIndexedPrimitive(pObject->GetVertexListPtr(),
										  pObject->GetVertexNum(),
										  pObject->GetPolyIndexListPtr(),
										  pObject->GetPrimitiveNum(),
										  eRT_FLAT);

	//4ڂ̃IuWFNg`

	//[hϊs쐬
	m.Scale(fScale,fScale,fScale);		//gs쐬
	mWorld = m;				
	m.RotateY(ry * RAD);				//x]s쐬	
	mWorld = mWorld * m;
	m.RotateX(ry * RAD);				//w]s쐬
	mWorld = mWorld * m;
	m.RotateZ(ry * RAD);				//y]s쐬
	mWorld = mWorld * m;
	m.Translate(fOffset,-fOffset,fZ);	//ֈړ
	mWorld = mWorld * m;
	
	//[hϊsZbg
	m_pRenderingMan->SetWorldMatrix(mWorld);

	//_O
	pObject = m_vecObjectList[eOBJ_TORUS]->pObject;
	m_pRenderingMan->DrawIndexedPrimitive(pObject->GetVertexListPtr(),
										  pObject->GetVertexNum(),
										  pObject->GetPolyIndexListPtr(),
										  pObject->GetPrimitiveNum(),
										  eRT_GOURAUD);

#endif 

#if 1	//́1ɂ

	//IuWFNg1zu
	{
		float fScale  = 15.0f;
		float fZ      = 30.0f;

		//[hϊs쐬
		m.Scale(fScale,fScale,fScale);		//gs쐬
		mWorld = m;				
		//m.RotateY(ry * RAD);				//x]s쐬	
		//mWorld = mWorld * m;
		//m.RotateX(ry * RAD);				//w]s쐬
		//mWorld = mWorld * m;
		//m.RotateZ(ry * RAD);				//y]s쐬
		//mWorld = mWorld * m;
		m.Translate(0.0,0.0,fZ);			//ֈړ
		mWorld = mWorld * m;
	
		m.RotateZ(ry * RAD);				//y]s쐬
		mWorld = mWorld * m;
	
		//[hϊsZbg
		m_pRenderingMan->SetWorldMatrix(mWorld);	

		//_O
		C3dObjectManBase *pObject;
		pObject = m_vecObjectList[eOBJ_SQUARE_XY]->pObject;
		m_pRenderingMan->DrawIndexedPrimitive(pObject->GetVertexListPtr(),
											  pObject->GetVertexNum(),
											  pObject->GetPolyIndexListPtr(),
											  pObject->GetPrimitiveNum(),
											  eRT_FLAT,true,80);
	}

#endif 
	{
		RGB32_TYPE tColor;
		tColor.R = 255; tColor.G = 255; tColor.B = 255;
	/*	int xo;
		int x = 100,y = 100;
		xo = m_pRenderingMan->DrawMoji(x,y,_mbsnextc((const unsigned char*)"M"),tColor,false);
		x += xo;
		xo = m_pRenderingMan->DrawMoji(x,y,_mbsnextc((const unsigned char*)"a"),tColor,false);
		x += xo;
		xo = m_pRenderingMan->DrawMoji(x,y,_mbsnextc((const unsigned char*)"d"),tColor,false);
		x += xo;
		xo = m_pRenderingMan->DrawMoji(x,y,_mbsnextc((const unsigned char*)"o"),tColor,false);
		x += xo;
		xo = m_pRenderingMan->DrawMoji(x,y,_mbsnextc((const unsigned char*)"k"),tColor,false);
		x += xo;
		xo = m_pRenderingMan->DrawMoji(x,y,_mbsnextc((const unsigned char*)"a"),tColor,false);
	*/
		m_pRenderingMan->DrawString(45,220,"Ƃ肠ŏIł",tColor,false);
	}

	//ʂɕ`
	m_pRenderingMan->Draw3dWorld(TRUE);

	//̉]
	ry+= 4;
	if(ry >= 360.0f) ry = 0;
}

