//---------------------------------------------------------------------------
//
//	CVectorMan.cpp	WƃxNg͉̏\(InR)I@xNg}NX
//
//                  xNg}34ł̍WlxNg₷
//                  ĂNXłB
//                  ɃxNgm̓ςOς̌vZ͖ɗ܂B
//                  xNg}͍s񉉎ZS̃}gbNX}Ƃǂ̂
//                  3Dł̌vZɔՂ\L邱Ƃł܂B
//
//	Programmed by Mikio Kusaka With Microsoft Visual C++ 6.0
//
//@^u͂SɂĂ
//---------------------------------------------------------------------------
// wb_[CN[h 
//---------------------------------------------------------------------------
#include <math.h>
#include "CVectorMan.h"
//---------------------------------------------------------------------------
// Cvg 
//---------------------------------------------------------------------------
CVectorMan3::CVectorMan3()
{

	//RXgN^̂P

	//o
	x = 0.0f;
	y = 0.0f;
	z = 0.0f;

}
//---------------------------------------------------------------------------
CVectorMan3::CVectorMan3(float vx,float vy,float vz)
{

	//RXgN^̂Q

	//o̒lŏ
	x = vx;
	y = vy;
	z = vz;

}
//---------------------------------------------------------------------------
CVectorMan3::CVectorMan3(CVectorMan3 &v)
{

	//Rs[RXgN^

	//o
	x = v.x;
	y = v.y;
	z = v.z;

}
//---------------------------------------------------------------------------
CVectorMan3::~CVectorMan3()
{

	//fXgN^
	
}
//---------------------------------------------------------------------------
void CVectorMan3::SetValue(float vx,float vy,float vz)
{

	//l̈ꊇZbg
	x = vx;
	y = vy;
	z = vz;

}
//---------------------------------------------------------------------------
float CVectorMan3::Length(void)
{

	//xNg̒擾

	return (float)sqrt(x*x + y*y + z*z);

}
//---------------------------------------------------------------------------
void CVectorMan3::Normalize(void)
{

	//PʃxNgɕϊ
	//PʃxNgƂ́AP̃xNĝ

	float len;
	
	len = (1.0f / (float)sqrt(x*x + y*y + z*z));
	
	x *= len;
	y *= len;
	z *= len;

}
//---------------------------------------------------------------------------
float CVectorMan3::DotProduct(CVectorMan3 &v)
{

	//ςvZ
	//ςƃxNgƃxNĝȂpx܂B

	return (x * v.x + y * v.y + z * v.z);

}
//---------------------------------------------------------------------------
void CVectorMan3::CrossProduct(CVectorMan3 &v1,CVectorMan3 &v2)
{

	//OςvZAi[
	//Oς͎ɖʂɐȖ@xNg߂邽߂ɎgpB
	
	x = v1.y * v2.z - v1.z * v2.y;
	y = v1.z * v2.x - v1.x * v2.z;
	z = v1.x * v2.y - v1.y * v2.x;

}
//---------------------------------------------------------------------------
void CVectorMan3::Invert(void)
{

	//xNg𔽓]
	
	x = -x;
	y = -y;
	z = -z;

}
//---------------------------------------------------------------------------
CVectorMan3 CVectorMan3::operator + (CVectorMan3 &v)
{

	//Z
	CVectorMan3 vv;

	vv.x = x + v.x;
	vv.y = y + v.y;
	vv.z = z + v.z;

	return vv;

}
//---------------------------------------------------------------------------
CVectorMan3 CVectorMan3::operator - (CVectorMan3 &v)
{

	//Z
	CVectorMan3 vv;

	vv.x = x - v.x;
	vv.y = y - v.y;
	vv.z = z - v.z;

	return vv;

}
//---------------------------------------------------------------------------
CVectorMan3 CVectorMan3::operator * (CVectorMan3 &v)
{

	//Z
	CVectorMan3 vv;

	vv.x = x * v.x;
	vv.y = y * v.y;
	vv.z = z * v.z;

	return vv;

}
//---------------------------------------------------------------------------
CVectorMan3 CVectorMan3::operator * (float f)
{

	//Z
	CVectorMan3 vv;

	vv.x = x * f;
	vv.y = y * f;
	vv.z = z * f;

	return vv;

}
//---------------------------------------------------------------------------
CVectorMan3 CVectorMan3::operator / (CVectorMan3 &v)
{

	//Z
	CVectorMan3 vv;

	vv.x = x / v.x;
	vv.y = y / v.y;
	vv.z = z / v.z;

	return vv;

}
//---------------------------------------------------------------------------
CVectorMan3 CVectorMan3::operator * (CMatrixMan4 &m)
{

	//xNgɍs
	//ꎟϊ

	CVectorMan3 v;

	v.x = m.m00 * x + m.m10 * y + m.m20 * z + m.m30;
	v.y = m.m01 * x + m.m11 * y + m.m21 * z + m.m31;
	v.z = m.m02 * x + m.m12 * y + m.m22 * z + m.m32;

	return v;

}
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
CVectorMan4::CVectorMan4()
{

	//RXgN^̂P

	//o
	x = 0.0f;
	y = 0.0f;
	z = 0.0f;
	w = 1.0f;

}
//---------------------------------------------------------------------------
CVectorMan4::CVectorMan4(float vx,float vy,float vz,float vw)
{

	//RXgN^̂Q

	//o̒lŏ
	x = vx;
	y = vy;
	z = vz;
	w = vw;

}
//---------------------------------------------------------------------------
CVectorMan4::CVectorMan4(CVectorMan3 &v)
{

	//RXgN^̂R

	//o
	x = v.x;
	y = v.y;
	z = v.z;
	w = 1.0f;

}
//---------------------------------------------------------------------------
CVectorMan4::CVectorMan4(CVectorMan4 &v)
{

	//Rs[RXgN^

	//o
	x = v.x;
	y = v.y;
	z = v.z;
	w = v.w;

}
//---------------------------------------------------------------------------
CVectorMan4::~CVectorMan4()
{

	//fXgN^
	
}
//---------------------------------------------------------------------------
void CVectorMan4::SetValue(float vx,float vy,float vz,float vw)
{

	//l̈ꊇZbg
	x = vx;
	y = vy;
	z = vz;
	w = vw;

}
//---------------------------------------------------------------------------
float CVectorMan4::Length(void)
{

	//xNg̒擾

	return (float)sqrt(x*x + y*y + z*z + w*w);

}
//---------------------------------------------------------------------------
void CVectorMan4::Normalize(void)
{

	//PʃxNgɕϊ
	//PʃxNgƂ́AP̃xNĝ

	float len;
	
	len = (1.0f / (float)sqrt(x*x + y*y + z*z + w*w));
	
	x *= len;
	y *= len;
	z *= len;
	w *= len;
	
}
//---------------------------------------------------------------------------
void CVectorMan4::Invert(void)
{

	//xNg𔽓]
	
	x = -x;
	y = -y;
	z = -z;
	w = -w;

}
//---------------------------------------------------------------------------
CVectorMan4 CVectorMan4::operator + (CVectorMan4 &v)
{

	//Z
	CVectorMan4 vv;

	vv.x = x + v.x;
	vv.y = y + v.y;
	vv.z = z + v.z;
	vv.w = w + v.w;

	return vv;

}
//---------------------------------------------------------------------------
CVectorMan4 CVectorMan4::operator - (CVectorMan4 &v)
{

	//Z
	CVectorMan4 vv;

	vv.x = x - v.x;
	vv.y = y - v.y;
	vv.z = z - v.z;
	vv.w = w - v.w;

	return vv;

}
//---------------------------------------------------------------------------
CVectorMan4 CVectorMan4::operator * (CVectorMan4 &v)
{

	//Z
	CVectorMan4 vv;

	vv.x = x * v.x;
	vv.y = y * v.y;
	vv.z = z * v.z;
	vv.w = w * v.w;

	return vv;

}
//---------------------------------------------------------------------------
CVectorMan4 CVectorMan4::operator / (CVectorMan4 &v)
{

	//Z
	CVectorMan4 vv;

	vv.x = x / v.x;
	vv.y = y / v.y;
	vv.z = z / v.z;
	vv.w = w / v.w;

	return vv;

}
//---------------------------------------------------------------------------
CVectorMan4 CVectorMan4::operator * (CMatrixMan4 &m)
{

	//xNgɍs
	//ꎟϊ

	CVectorMan4 v;

	v.x = m.m00 * x + m.m10 * y + m.m20 * z + m.m30 * w;
	v.y = m.m01 * x + m.m11 * y + m.m21 * z + m.m31 * w;
	v.z = m.m02 * x + m.m12 * y + m.m22 * z + m.m32 * w;
	v.w = m.m03 * x + m.m13 * y + m.m23 * z + m.m33 * w;

	return v;

}
//---------------------------------------------------------------------------
