//---------------------------------------------------------------------------
// Madoka Demo 2006 ܂ǂ̎Ȗ3Df2006
//
// C3dObjectMan.cpp f[^̂ƂȂ牴ɕĂI  3DIuWFNg}NX
//
//                  3DIuWFNg}NX̓L[u()^⋅^A
//                  g[X(h[ic)^Ȃǂ3DIuWFNg̒_Wf[^
//                  |S`邽߂̒_CfbNXȂǂǗNX
//                  łB
//                  {IȊOƂ̃C^[tF[XC3dObjectManBaseSA
//                  hNXł͊eX̒_XgǗ邱ƂɂȂ܂B
// 
// Programmed by Mikio Kusaka With Microsoft Visual C++ .Net2003
//
//---------------------------------------------------------------------------
#if _MSC_VER > 1200
	#define _USE_MATH_DEFINES	//`邱ƂɂAmath.hM_PIȂǂ
								//}Ngpł悤ɂȂ܂B
								//VC++.Net(VC7)ȍ~
#else
	#define M_PI       3.14159265358979323846
#endif //_MSC_VER > 1200
#include <math.h>
#include "C3dObjectMan.h"
#include "CMatrixMan.h"

//---------------------------------------------------------------------------
// C3dObjectManNX 
//---------------------------------------------------------------------------
C3dObjectManBase::C3dObjectManBase()
{

	//RXgN^

	//ȍ
	InitMember();

}
//---------------------------------------------------------------------------
C3dObjectManBase::~C3dObjectManBase()
{

	//fXgN^
	
	//IuWFNg̃NA
	ClearObject();
}
//---------------------------------------------------------------------------
void C3dObjectManBase::InitMember(void)
{

	//ȍ
	
	m_paVertex               = NULL;
	m_paiPolyIndex           = NULL;
	m_iVertexNum             = 0;
	m_iVertexNumForPrimitive = DEFAULT_VERTEX_NUM_FOR_PRIMITIVE;
	m_iPrimitiveNum          = 0;

}
//---------------------------------------------------------------------------
void C3dObjectManBase::ClearObject(void)
{

	//IuWFNg̃NA
	
	//_f[^̍폜
	if(m_paVertex != NULL)
	{
		delete[] m_paVertex;
		m_paVertex = NULL;
	}
	if(m_paiPolyIndex != NULL)
	{
		delete[] m_paiPolyIndex;
		m_paiPolyIndex = NULL;
	}

	//ȍ
	InitMember();
	
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// CSquareXYObjManNX 
//---------------------------------------------------------------------------
CSquareXYObjMan::CSquareXYObjMan()
{

	//RXgN^

	//x[XNXł̏ȊOɏ
	//̂͂܂

	//L[uIuWFNg쐬
	Create();
}
//---------------------------------------------------------------------------
CSquareXYObjMan::~CSquareXYObjMan()
{

	//fXgN^
	
	//ɉ̂͂܂
	//̃fXgN^̌Ax[XNX(C3dObjectManBase)
	//̃fXgN^Ăяo܂

}
//---------------------------------------------------------------------------
void CSquareXYObjMan::Create(void)
{

	//IuWFNg̐

	//ȑÕf[^j
	ClearObject();

	//f[^̈̊m
	int iTotalVertex    = 4;								//_̐
	int iTotalPolygon   = 2;								//|S̐
	int iTotalPolyIndex = iTotalPolygon *					//_CfbNX
						  DEFAULT_VERTEX_NUM_FOR_PRIMITIVE;	//̑

	m_paVertex      = new CVertexMan[iTotalVertex];
	m_paiPolyIndex  = new int[iTotalPolyIndex];
	m_iVertexNum    = iTotalVertex;
	m_iPrimitiveNum = iTotalPolygon;

	// ̂̒_͈ȉ̏ԂŌv4_ɂȂ܂
	//
	// 0-----3 
	// |     |
    // |     |
	// 1-----2
	//
	// eӂ̒͂Ƃ肠1.0ƂēK
	// g債Ďg܂
	//	
	m_paVertex[0].vv.x = -0.5f; m_paVertex[0].vv.y =  0.5f; m_paVertex[0].vv.z = 0.0f;
	m_paVertex[1].vv.x = -0.5f; m_paVertex[1].vv.y = -0.5f; m_paVertex[1].vv.z = 0.0f;
	m_paVertex[2].vv.x =  0.5f; m_paVertex[2].vv.y = -0.5f; m_paVertex[2].vv.z = 0.0f;
	m_paVertex[3].vv.x =  0.5f; m_paVertex[3].vv.y =  0.5f; m_paVertex[3].vv.z = 0.0f;
	
	// |S`pɊe_̕`揇CfbNX쐬
	//
	// Op`|S̖ʂ̌(@xNg)́AR_
	// (A,B,C)ɁAxNgƂĂAB֐Lт
	// xNgAC֐LтxNgɃvX
	// ꍇ(ȉ̐}Q)AABC̖@xNg
	// O(-Z)ɂȂ܂B
	//
	//       B-----D
	//  +Y   |_@ |
	//  |    |@_ |
	//  |    A-----C
	//  |
	//  +------+X (Wn@+Z)
	//
    // ܂A+ZĂ鎋ɑ΂Č
	// (@xNgƎxNg)낤
	// ƎvA_̕`揇A,B,CƂɂȂ
	// Kv܂B
	// ̖@ɊÂāAЂƂ́BCD̎O
	// 钸_̕`揇́AC,B,DɂȂ܂B
	//
	int aiDrawIndex[] = 
	{
		1,0,2, 2,0,3,		
	};
	int i;
	for(i = 0;i < iTotalPolyIndex;++i)
	{
		m_paiPolyIndex[i] = aiDrawIndex[i];
	}

}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// CSquareXZObjManNX 
//---------------------------------------------------------------------------
CSquareXZObjMan::CSquareXZObjMan()
{

	//RXgN^

	//x[XNXł̏ȊOɏ
	//̂͂܂

	//L[uIuWFNg쐬
	Create();
}
//---------------------------------------------------------------------------
CSquareXZObjMan::~CSquareXZObjMan()
{

	//fXgN^
	
	//ɉ̂͂܂
	//̃fXgN^̌Ax[XNX(C3dObjectManBase)
	//̃fXgN^Ăяo܂

}
//---------------------------------------------------------------------------
void CSquareXZObjMan::Create(void)
{

	//IuWFNg̐

	//ȑÕf[^j
	ClearObject();

	//f[^̈̊m
	int iTotalVertex    = 4;								//_̐
	int iTotalPolygon   = 2;								//|S̐
	int iTotalPolyIndex = iTotalPolygon *					//_CfbNX
						  DEFAULT_VERTEX_NUM_FOR_PRIMITIVE;	//̑

	m_paVertex      = new CVertexMan[iTotalVertex];
	m_paiPolyIndex  = new int[iTotalPolyIndex];
	m_iVertexNum    = iTotalVertex;
	m_iPrimitiveNum = iTotalPolygon;

	// ̂̒_͈ȉ̏ԂŌv4_ɂȂ܂
	//
	// 0-----3 
	// |     |
    // |     |
	// 1-----2
	//
	// eӂ̒͂Ƃ肠1.0ƂēK
	// g債Ďg܂
	//	
	m_paVertex[0].vv.x = -0.5f; m_paVertex[0].vv.y = 0.0f; m_paVertex[0].vv.z =  0.5f;
	m_paVertex[1].vv.x = -0.5f; m_paVertex[1].vv.y = 0.0f; m_paVertex[1].vv.z = -0.5f;
	m_paVertex[2].vv.x =  0.5f; m_paVertex[2].vv.y = 0.0f; m_paVertex[2].vv.z = -0.5f;
	m_paVertex[3].vv.x =  0.5f; m_paVertex[3].vv.y = 0.0f; m_paVertex[3].vv.z =  0.5f;
	
	// |S`pɊe_̕`揇CfbNX쐬
	//
	// Op`|S̖ʂ̌(@xNg)́AR_
	// (A,B,C)ɁAxNgƂĂAB֐Lт
	// xNgAC֐LтxNgɃvX
	// ꍇ(ȉ̐}Q)AABC̖@xNg
	// O(+Y)ɂȂ܂B
	//
	//       B-----D
	//  +Z   |_@ |
	//  |    |@_ |
	//  |    A-----C
	//  |
	//  +------+X (Wn@O+Y)
	//
    // ܂A+ZĂ鎋ɑ΂Č
	// (@xNgƎxNg)낤
	// ƎvA_̕`揇A,B,CƂɂȂ
	// Kv܂B
	// ̖@ɊÂāAЂƂ́BCD̎O
	// 钸_̕`揇́AC,B,DɂȂ܂B
	//
	int aiDrawIndex[] = 
	{
		1,0,2, 2,0,3,		
	};
	int i;
	for(i = 0;i < iTotalPolyIndex;++i)
	{
		m_paiPolyIndex[i] = aiDrawIndex[i];
	}

}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// CQubeObjManNX 
//---------------------------------------------------------------------------
CQubeObjMan::CQubeObjMan()
{

	//RXgN^

	//x[XNXł̏ȊOɏ
	//̂͂܂

	//L[uIuWFNg쐬
	Create();
}
//---------------------------------------------------------------------------
CQubeObjMan::~CQubeObjMan()
{

	//fXgN^
	
	//ɉ̂͂܂
	//̃fXgN^̌Ax[XNX(C3dObjectManBase)
	//̃fXgN^Ăяo܂

}
//---------------------------------------------------------------------------
void CQubeObjMan::Create(void)
{

	//IuWFNg̐

	//ȑÕf[^j
	ClearObject();

	//f[^̈̊m
	int iTotalVertex    = 4 * 2;							//_̐
	int iTotalPolygon   = 6 * 2;							//|S̐
	int iTotalPolyIndex = iTotalPolygon *					//_CfbNX
						  DEFAULT_VERTEX_NUM_FOR_PRIMITIVE;	//̑

	m_paVertex      = new CVertexMan[iTotalVertex];
	m_paiPolyIndex  = new int[iTotalPolyIndex];
	m_iVertexNum    = iTotalVertex;
	m_iPrimitiveNum = iTotalPolygon;

	// ̂̒_͈ȉ̏ԂőOƌ
	// v8_ɂȂ܂
	//
	// 0-----3 
	// |     |
    // |     |
	// 1-----2
	//
	// eӂ̒͂Ƃ肠1.0ƂēK
	// g債Ďg܂
	//	
	m_paVertex[0].vv.x = -0.5f; m_paVertex[0].vv.y =  0.5f; m_paVertex[0].vv.z = -0.5f;
	m_paVertex[1].vv.x = -0.5f; m_paVertex[1].vv.y = -0.5f; m_paVertex[1].vv.z = -0.5f;
	m_paVertex[2].vv.x =  0.5f; m_paVertex[2].vv.y = -0.5f; m_paVertex[2].vv.z = -0.5f;
	m_paVertex[3].vv.x =  0.5f; m_paVertex[3].vv.y =  0.5f; m_paVertex[3].vv.z = -0.5f;
	m_paVertex[4].vv.x = -0.5f; m_paVertex[4].vv.y =  0.5f; m_paVertex[4].vv.z =  0.5f;
	m_paVertex[5].vv.x = -0.5f; m_paVertex[5].vv.y = -0.5f; m_paVertex[5].vv.z =  0.5f;
	m_paVertex[6].vv.x =  0.5f; m_paVertex[6].vv.y = -0.5f; m_paVertex[6].vv.z =  0.5f;
	m_paVertex[7].vv.x =  0.5f; m_paVertex[7].vv.y =  0.5f; m_paVertex[7].vv.z =  0.5f;

	// |S`pɊe_̕`揇CfbNX쐬
	//
	// Op`|S̖ʂ̌(@xNg)́AR_
	// (A,B,C)ɁAxNgƂĂAB֐Lт
	// xNgAC֐LтxNgɃvX
	// ꍇ(ȉ̐}Q)AABC̖@xNg
	// O(-Z)ɂȂ܂B
	// 
	//       B-----D
	//  +Y   |_@ |
	//  |    |@_ |
	//  |    A-----C
	//  |
	//  +------+X (Wn@+Z)
	// 
    // ܂A+ZĂ鎋ɑ΂Č
	// (@xNgƎxNg)낤
	// ƎvA_̕`揇A,B,CƂɂȂ
	// Kv܂B
	// ̖@ɊÂāAЂƂ́BCD̎O
	// 钸_̕`揇́AC,B,DɂȂ܂B
	//
	int aiDrawIndex[] = 
	{
		1,0,2, 2,0,3,
		0,4,3, 3,4,7,
		4,5,7, 7,5,6,
		5,1,6, 6,1,2,
		3,7,2, 2,7,6,
		1,5,0, 0,5,4,		
	};
	int i;
	for(i = 0;i < iTotalPolyIndex;++i)
	{
		m_paiPolyIndex[i] = aiDrawIndex[i];
	}

}
//---------------------------------------------------------------------------
	
//---------------------------------------------------------------------------
// CTorusObjManNX 
//---------------------------------------------------------------------------
CTorusObjMan::CTorusObjMan() : C3dObjectManBase()
{

	//RXgN^
	
	//x[XNXł̏ȊOɏ
	//̂͂܂

	//ftHg̕ŃIuWFNg𐶐܂
	Create(DEFAULT_TORUS_NUM);

}
//---------------------------------------------------------------------------
CTorusObjMan::CTorusObjMan(int n) : C3dObjectManBase()
{

	//RXgN^@̂Q
	//n͊{Ƃ鑽p`̕(:Zp`=6)

	//IuWFNg쐬
	Create(n);

}
//---------------------------------------------------------------------------
CTorusObjMan::~CTorusObjMan()
{

	//fXgN^

	//ɉ̂͂܂
	//̃fXgN^̌Ax[XNX(C3dObjectManBase)
	//̃fXgN^Ăяo܂

}
//---------------------------------------------------------------------------
void CTorusObjMan::Create(void)
{

	//IuWFNg̐

	//ftHg̕ŃIuWFNg𐶐܂
	Create(DEFAULT_TORUS_NUM);

}
//---------------------------------------------------------------------------
void CTorusObjMan::Create(int n)
{

	//IuWFNg̐
	//int n c {Ƃ鑽p`̕(:Zp`=6)
	
	//ȑÕf[^j
	ClearObject();

	//f[^̈̊m
	int iTotalVertex    = n * n;							//_̐
	int iTotalPolygon   = iTotalVertex  * 2;				//|S̐
	int iTotalPolyIndex = iTotalPolygon *					//_CfbNX
						  DEFAULT_VERTEX_NUM_FOR_PRIMITIVE;	//̑

	m_paVertex      = new CVertexMan[iTotalVertex];
	m_paiPolyIndex  = new int[iTotalPolyIndex];
	m_iVertexNum    = iTotalVertex;
	m_iPrimitiveNum = iTotalPolygon;

	//np`̊e_WY𒆐Sɏォ猩np`ɂȂ悤ɉ]
	//g[X}`܂
	//́A{ƂȂnp`X-Yʂō쐬AXnp`̒as
	//ړAY𒆐S360/nx]邱ƂōWvZł܂
	//

	//np`̊{Wݒ
	CVectorMan4 *paBaseVector = new CVectorMan4[n];
	float fRadius   = 0.4f;								//np`̔a
	float fAngle    = 0.0f;								//np`̊px
	float fAddAngle = (float)(M_PI * 2.0 / (double)n);	//np`̊pxl
	int i;
	for(i = 0;i < n;++i,fAngle += fAddAngle)
	{
		paBaseVector[i].x = fRadius * (float)cos(fAngle);
		paBaseVector[i].y = fRadius * (float)sin(fAngle);
		paBaseVector[i].z = 0.0f;
	}

	//{}`np`̒aXɕsړ邽߂
	//sړs쐬
	CMatrixMan4 mMove;
	mMove.Translate(fRadius * 2.0f,0.0f,0.0f);

	//{}`𕽍sړAY𒆐Sɉ]
	//g[X}`̒_WvZ܂
	int iIndex = 0;
	int j;
	fAngle = 0.0f;
	for(i = 0;i < n;++i,fAngle += fAddAngle)
	{
		//]s쐬
		CMatrixMan4 mRotate;
		mRotate.RotateY(fAngle);

		//sړsƍ
		CMatrixMan4 m;
		m.Initialize();
		m = m * mMove;
		m = m * mRotate;

		//{}`ϊčW쐬
		for(j = 0;j < n;++j)
		{
			m_paVertex[iIndex++].vv = paBaseVector[j] * m;
		}
	}	
	delete[] paBaseVector;

	//|Sp_̕`揇CfbNXXg쐬
	iIndex = 0;
	
	//YS(X-Z)̉][v	
	int xy,xz;
	for(xz = 0;xz < n;++xz)
	{
		int firstpos = n * xz;	//ep`̍ŏ̒_̃CfbNX

		//X-Yʂł̑p`_[v
		//
		// |S̕\ʂO悤ɁAȉ̗̐v̂Œ_̕`揇ݒ
		//
		// Op`|S̖ʂ̌(@xNg)́AR_
		// (A,B,C)ɁAxNgƂĂAB֐Lт
		// xNgAC֐LтxNgɃvX
		// ꍇ(ȉ̐}Q)AABC̖@xNg
		// O(-Z)ɂȂ܂B
		// 
		//       B-----D
		//  +Y   |_@ |
		//  |    |@_ |
		//  |    A-----C
		//  |
		//  +------+X (Wn@+Z)
		//
		// ܂A+ZĂ鎋ɑ΂Č
		// (@xNgƎxNg)낤
		// ƎvA_̕`揇A,B,CƂɂȂ
		// Kv܂B
		// ̖@ɊÂāAЂƂ́BCD̎O
		// 钸_̕`揇́AC,B,DɂȂ܂B
		//	
		for(xy = 0;xy < n;++xy)
		{
			//ԍ4p`g[Xł̃CfbNX
			m_paiPolyIndex[iIndex++] =   firstpos +   xy;										//0	
			m_paiPolyIndex[iIndex++] =   firstpos + ((xy + n - 1)  % n);						//3	
			m_paiPolyIndex[iIndex++] =  (firstpos +  (xy + n    ))           % iTotalVertex;	//4		
			m_paiPolyIndex[iIndex++] =   firstpos + ((xy + n - 1)  % n);						//3				
			m_paiPolyIndex[iIndex++] = ((firstpos +  (xy + n - 1)  % n) + n) % iTotalVertex;	//7	
			m_paiPolyIndex[iIndex++] =  (firstpos +  (xy + n    ))           % iTotalVertex;	//4	
		}
	}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// CCylinderObjManNX 
//---------------------------------------------------------------------------
CCylinderObjMan::CCylinderObjMan() : C3dObjectManBase()
{

	//RXgN^
	
	//x[XNXł̏ȊOɏ
	//̂͂܂

	//ftHg̕ŃIuWFNg𐶐܂
	Create(DEFAULT_CYLINDER_NUM);

}
//---------------------------------------------------------------------------
CCylinderObjMan::CCylinderObjMan(int n) : C3dObjectManBase()
{

	//RXgN^@̂Q
	//n͊{Ƃ鑽p`̕(:Zp`=6)

	//IuWFNg쐬
	Create(n);

}
//---------------------------------------------------------------------------
CCylinderObjMan::~CCylinderObjMan()
{

	//fXgN^

	//ɉ̂͂܂
	//̃fXgN^̌Ax[XNX(C3dObjectManBase)
	//̃fXgN^Ăяo܂

}
//---------------------------------------------------------------------------
void CCylinderObjMan::Create(void)
{

	//IuWFNg̐

	//ftHg̕ŃIuWFNg𐶐܂
	Create(DEFAULT_CYLINDER_NUM);

}
//---------------------------------------------------------------------------
void CCylinderObjMan::Create(int n)
{

	//IuWFNg̐
	//int n c {Ƃ鑽p`̕(:Zp`=6)
	
	//ȑÕf[^j
	ClearObject();

	//f[^̈̊m
	int iTotalVertex    = n * 2;							//_̐
	int iTotalPolygon   = iTotalVertex  * 2;				//|S̐
	int iTotalPolyIndex = iTotalPolygon *					//_CfbNX
						  DEFAULT_VERTEX_NUM_FOR_PRIMITIVE;	//̑

	m_paVertex      = new CVertexMan[iTotalVertex];
	m_paiPolyIndex  = new int[iTotalPolyIndex];
	m_iVertexNum    = iTotalVertex;
	m_iPrimitiveNum = iTotalPolygon;

	//X-Zʏnp`̒_zuAYɉčL邱Ƃŉ~
	//IuWFNg쐬܂B

	//np`̊{Wݒ
	float fRadius   = 0.4f;								//np`̔a
	float fAngle    = 0.0f;								//np`̊px
	float fAddAngle = (float)(M_PI * 2.0 / (double)n);	//np`̊pxl
	int i;
	for(i = 0;i < n;++i,fAngle += fAddAngle)
	{
		m_paVertex[  i].vv.x = fRadius * (float)cos(fAngle);	//㑤np`
		m_paVertex[  i].vv.z = fRadius * (float)sin(fAngle);		
		m_paVertex[  i].vv.y =  0.5f;
		m_paVertex[n+i].vv.x = fRadius * (float)cos(fAngle);	//np`
		m_paVertex[n+i].vv.z = fRadius * (float)sin(fAngle);		
		m_paVertex[n+i].vv.y = -0.5f;
	}

	//|Sp_̕`揇CfbNXXg쐬
	int iIndex = 0;
	
	for(i = 0;i < n;++i)
	{
		//X-Yʂł̑p`_[v
		//
		// |S̕\ʂO悤ɁAȉ̗̐v̂Œ_̕`揇ݒ
		//
		// Op`|S̖ʂ̌(@xNg)́AR_
		// (A,B,C)ɁAxNgƂĂAB֐Lт
		// xNgAC֐LтxNgɃvX
		// ꍇ(ȉ̐}Q)AABC̖@xNg
		// O(-Z)ɂȂ܂B
		// 
		//       B-----D
		//  +Y   |_@ |
		//  |    |@_ |
		//  |    A-----C
		//  |
		//  +------+X (Wn@+Z)
		//
		// ܂A+ZĂ鎋ɑ΂Č
		// (@xNgƎxNg)낤
		// ƎvA_̕`揇A,B,CƂɂȂ
		// Kv܂B
		// ̖@ɊÂāAЂƂ́BCD̎O
		// 钸_̕`揇́AC,B,DɂȂ܂B
		//	
		
		//ԍ4pł̃CfbNX

		//O|S̍쐬
		m_paiPolyIndex[iIndex++] =   i + n;							//4	
		m_paiPolyIndex[iIndex++] =   i;								//0	
		m_paiPolyIndex[iIndex++] =   (i + 1) % n + n;				//5	
		m_paiPolyIndex[iIndex++] =   (i + 1) % n + n;				//5	
		m_paiPolyIndex[iIndex++] =   i;								//0	
		m_paiPolyIndex[iIndex++] =   (i + 1) % n;					//1	
		
		//|S̍쐬
		m_paiPolyIndex[iIndex++] =   i + n;							//4	
		m_paiPolyIndex[iIndex++] =   (i + 1) % n + n;				//5	
		m_paiPolyIndex[iIndex++] =   i;								//0	
		m_paiPolyIndex[iIndex++] =   (i + 1) % n + n;				//5	
		m_paiPolyIndex[iIndex++] =   (i + 1) % n;					//1	
		m_paiPolyIndex[iIndex++] =   i;								//0	
	}
}
//---------------------------------------------------------------------------

