//---------------------------------------------------------------------------
// 1ŏoRcupTv  
//
// C3dObjectMan.cpp f[^̂ƂȂ牴ɕĂI
//                  3DIuWFNg}NXwb_[
//
//                  3DIuWFNg}NX̓L[u()^⋅^A
//                  g[X(h[ic)^Ȃǂ3DIuWFNg̒_Wf[^
//                  |S`邽߂̒_CfbNXȂǂǗNX
//                  łB
//                  {IȊOƂ̃C^[tF[XC3dObjectManBaseSA
//                  hNXł͊eX̒_XgǗ邱ƂɂȂ܂B
// 
// Programmed by Mikio Kusaka With Microsoft Visual C++ .Net2003
//
//---------------------------------------------------------------------------
#pragma once	//ł̃wb_t@C1񂵂ǂ܂Ȃ悤ɂĂ邪A
				//  gȂRpĈ݂ŁAӂ邱ƁB
				//  ŋ߂̎vȃRpC(VC,gcc,bc,CodeWarriorjł͎g݂B

#include "CVectorMan.h"
//---------------------------------------------------------------------------
// 萔 
//---------------------------------------------------------------------------
#define DEFAULT_VERTEX_NUM_FOR_PRIMITIVE	(3)		//ftHg1v~eBu
													//̒_(ftHg
													//͎Op`|SȂ̂3)
	
#define DEFAULT_TORUS_NUM					(6)		//g[XIuWFNg
													//ftHg

#define DEFAULT_CYLINDER_NUM				(10)	//V_[(~)IuWF
													//Ng̃ftHg


//---------------------------------------------------------------------------
// NX` 
//---------------------------------------------------------------------------
//_f[^ǗNX o[ebNX}
//
//悤I
//  o[ebNX}Ƃ́A|S`钸_̍W⑮ǗĂ
//  NX̂ƂłB
//  _gp|S`悷Ƃɂ̓ooplC҂ɂȂ邼I
//
class CVertexMan
{
public:

	CVectorMan4 vv;	//_W(X̍Wϊɓsǂ悤4ɂĂ܂)
	CVectorMan3 vn;	//_̖@xNg
	
	int iUse;		//|Sgݍ킹̒_gp
					//̒_𗘗pe|S̖@xNg𕽋ωāA
					//̒_̖@xNgZoۂɗp܂B

	int iR,iG,iB;	//_J[
	
	bool bActive;	//ȈՉ(true:)

	//TODO X̓eNX`UVWǉăeNX`}bsO\ɁI(^o^)

	//RXgN^
	CVertexMan()
	{
		iR = iG = iB = 0;
		iUse    = 0;
		bActive = false;
	}

	//fXgN^
	virtual ~CVertexMan(){}

	//_̖@xNgvZ
	void CalcVertexNormalVector(void)
	{
		float fUse = (float)iUse;

		vn.x /= fUse;
		vn.y /= fUse;
		vn.z /= fUse;
	}

};
//---------------------------------------------------------------------------
//3DIuWFNg̃x[XNX(OC^[tF[XS)@3DIuWFNg}x[X
//
//悤I
//  3DIuWFNg}x[XƂ́ASĂ3DIuWFNgǗNX̋ʊOC^[
//  tF[XAWf[^̕ێE폜SĂ鉏̗͎̉I
//  `S郌_O}ƃ^bOg߂̂́A3DIuWFNg}x[X
//  ̔hNXƂƂYȁI
//
class C3dObjectManBase
{
protected:
	
	CVertexMan  *m_paVertex;			//_f[^Xg
	int         *m_paiPolyIndex;		//|S`钸_
										//CfbNXXg
	
	int       m_iVertexNum;				//_
	int       m_iVertexNumForPrimitive;	//1v~eBu̒_
										//(ʏ3=Op`|S)
	int		  m_iPrimitiveNum;			//v~eBu̐
	
	//ȍ
	virtual void InitMember(void);

	//IuWFNg̃NA
	virtual void ClearObject(void);
	
public:

	//RXgN^
	C3dObjectManBase();

	//fXgN^
	virtual ~C3dObjectManBase();

	//_f[^Xgւ̃|C^擾
	CVertexMan* GetVertexListPtr(void)
	{
		return m_paVertex;
	}

	//|S`揇_CfbNXXgւ̃|C^擾
	int* GetPolyIndexListPtr(void)
	{
		return m_paiPolyIndex;
	}
    
	//_WXg̒_擾
	int GetVertexNum(void)
	{
		return m_iVertexNum;
	}

	//1v~eBu̒_̎擾
	int GetVertexNumForPrimitive(void)
	{
		return m_iVertexNumForPrimitive;
	}

	//IuWFNg̃v~eBu̎擾
	int GetPrimitiveNum(void)
	{
		return m_iPrimitiveNum;
	}

	//IuWFNg(ftHgݒō쐬)
	//z֐Ȃ̂ŁAhNX͕KCreate
	//  \bhI[o[Ch邱
	virtual void Create(void) = 0;

};

//---------------------------------------------------------------------------
//lp`IuWFNg(X-Y)NX@XNEFAXYIuWFNg}
//
//悤I
//  XNEFAXYIuWFNg}Ƃ́AX-YʂƕsȎlp`IuWFNg̒_
//  f[^ǗNXI
//  ɑ΂Đɑ݂̂ŕǂȂǂ\̂ɍœK낤B
//
class CSquareXYObjMan : public C3dObjectManBase
{
protected:


public:

	//RXgN^
	CSquareXYObjMan();
	
	//fXgN^
	virtual ~CSquareXYObjMan();

	//IuWFNg̐
	void Create(void);
	
};

//---------------------------------------------------------------------------
//lp`IuWFNg(X-Z)NX@XNEFAXZIuWFNg}
//
//悤I
//  XNEFAXZIuWFNg}Ƃ́AX-ZʂƕsȎlp`IuWFNg̒_
//  f[^ǗNXI
//  ɑ΂ĕsɑ݂̂Œn()Ȃǂ\̂ɍœK낤B
//
class CSquareXZObjMan : public C3dObjectManBase
{
protected:


public:

	//RXgN^
	CSquareXZObjMan();
	
	//fXgN^
	virtual ~CSquareXZObjMan();

	//IuWFNg̐
	void Create(void);
	
};

//---------------------------------------------------------------------------
//L[u()IuWFNgNX@L[uIuWFNg}
//
//悤I
//  L[uIuWFNg}Ƃ́A3DIuWFNg̊{`Ƃ闧̃IuWFNg
//  ̒_f[^ǗNXI
//  e3DIuWFNgł̃|S̒`̊{̃L[uIuWFNg}ɂ
//  ̂ŁA\[XnǂāAK}X^[ĂׂI
//
class CQubeObjMan : public C3dObjectManBase
{
protected:


public:

	//RXgN^
	CQubeObjMan();
	
	//fXgN^
	virtual ~CQubeObjMan();

	//IuWFNg̐
	void Create(void);
	
};

//---------------------------------------------------------------------------
//g[X(h[ic^)IuWFNgNX@g[XIuWFNg}
//
//悤I
//  g[XIuWFNg}Ƃ́A3DČg[X@ƂA
//  W[3DIuWFNgłg[X^̒_f[^ǗNXI
//  \z̈ɂāA|S̕ύXł̂ŁA낢뎎Ă݂
//  ʔI@A𑝂₵Ƃ̕`悷ׂ|S
//  `悪dȂ邩璍ӂKvB߂͋֕ƂƂȁB
//
class CTorusObjMan : public C3dObjectManBase
{
protected:


public:

	//RXgN^
	CTorusObjMan();
	CTorusObjMan(int n);	//n͊{Ƃ鑽p`̕(:Zp`=6)

	//fXgN^
	virtual ~CTorusObjMan();

	//IuWFNg̐
	//int n c {Ƃ鑽p`̕(:Zp`=6)
	//
	//̏ꍇAftHg̕ō쐬܂
	void Create(void);
	void Create(int n);

};

//---------------------------------------------------------------------------
//V_[(~^)IuWFNgNX@V_[IuWFNg}
//
//悤I
//  V_[IuWFNg}Ƃ́A~^̒_f[^ǗNXI
//  g[XIuWFNg}lA\z̈ɂāA|S̕ύX
//  ł邪A͂߂͋֕I
//  ̃V_[IuWFNg}ł́AIuWFNg̓ɂ|SzuA
//  悤ɂȂĂ̂łƖʔB
//
class CCylinderObjMan : public C3dObjectManBase
{
protected:


public:

	//RXgN^
	CCylinderObjMan();
	CCylinderObjMan(int n);	//n͊{Ƃ鑽p`̕(:Zp`=6)

	//fXgN^
	virtual ~CCylinderObjMan();

	//IuWFNg̐
	//int n c {Ƃ鑽p`̕(:Zp`=6)
	//
	//̏ꍇAftHg̕ō쐬܂
	void Create(void);
	void Create(int n);

};

//---------------------------------------------------------------------------
