//---------------------------------------------------------------------------
// Madoka Demo 2006 ܂ǂ̎Ȗ3Df2006
//
// CRenderingMan.h `̂ƂȂ牴ɔCI@_O}NXwb_[
//
//                 _O}3DIuWFNg̍Wϊ
//                 C[t[E|S`Ȃǂ̕`
//                 bĂNXł
//                 ̃_O}ɍs񉉎ZS̃}gbNX}
//                 3DIuWFNg̍WǗS3DIuWFNg}
//                 x[X̔hNXĂ΁AwʂɃ|S
//                 ʂɕ\Ă܂B
//                 _O}cc@zI(^[^
// 
// Programmed by Mikio Kusaka With Microsoft Visual C++ .Net2003
//
//---------------------------------------------------------------------------
#pragma once	//ł̃wb_t@C1񂵂ǂ܂Ȃ悤ɂĂ邪A
				//  gȂRpĈ݂ŁAӂ邱ƁB
				//  ŋ߂̎vȃRpC(VC,gcc,bc,CodeWarriorjł͎g݂B

#include "CMatrixMan.h"
#include "C3dObjectMan.h"	//قƂCVertexManŃwb_ǂ
//---------------------------------------------------------------------------
// 萔 
//---------------------------------------------------------------------------
#define PI						(3.14159265358979f)	//
#define RAD						(PI/180.0f)			//WAϊpW
#define INVALID_Z_VALUE			(10000.0f)			//Zl	
#define DEFAULT_AMBIENT_LIGHT	(0.2f)				//ftHg̊̒l(R/G/B)
#define DEFAULT_DEFUSE_LIGHT	(0.8f)				//ftHg̊gU̒l(R/G/B)
#define DEFAULT_LIGHT_X			( 1.0f)				//ftHǧxNgX
#define DEFAULT_LIGHT_Y			(-1.0f)				//ftHǧxNgY
#define DEFAULT_LIGHT_Z			( 1.0f)				//ftHǧxNgZ
													//WȂxNg()
													//̌Ă
#define MAX_Z_POS				(1000.0f)			//`拖Z̍ől
#define SCREEN_FONT_HEIGHT		(20)				//XN[tHg̍
#define SCREEN_FONT_NAME		"lr oSVbN"	//XN[tHg̖O

//`@ʒ萔
typedef enum
{
	eRT_WIRE = 0,		//C[t[
	eRT_WIRE_AA,		//C[t[A`GAXC()
	eRT_FLAT,			//tbgVF[fBO
	eRT_GOURAUD,		//O[[VF[fBO(񐄏)
	eRT_PHONE,			//tHVF[fBO()

} RENDER_TYPE_ENUM;


//---------------------------------------------------------------------------
// \ 
//---------------------------------------------------------------------------
//32bitsNZ\
typedef struct tag_RGB32_type
{
	BYTE B;		//B
	BYTE G;		//G
	BYTE R;		//R
	BYTE A;		//At@lƂėpH
	
} RGB32_TYPE;


//---------------------------------------------------------------------------
// NX` 
//---------------------------------------------------------------------------
class CRenderingMan
{
private:

	HWND			m_hTargetWnd;				//`EChẼnh

	int				m_iScreenWidth;				//`XN[̕
	int				m_iScreenHeight;			//`XN[̍

	BITMAPINFO		m_tOffScreenBMPInfo;		//ItXN[obt@BMP
	HDC				m_hOffScreenDC;				//ItXN[obt@p̃
												//DCnh
	HBITMAP			m_hOldBMP;					//BMPOpBMPnh(DC
												//̃ftHgBMPnh)
	BYTE		   *m_pbyOffScreenDIB;			//ItXN[obt@DIB|C^

	HFONT			m_hScreenFont;				//gptHg
	HFONT			m_hOldFont;					//ItXN[DC̃ftHgtHgnh

	int			   *m_paiMinX;					//YC̍ŏXWlXg
	int			   *m_paiMaxX;					//YC̍őXWlXg
	float		   *m_pafZBuffer;				//ItXN[obt@ŜZobt@
	float		   *m_pafMinZ;					//YC̍ŏXWZlXg
	float		   *m_pafMaxZ;					//YC̍őXWZlXg
	float		   *m_pafMinR;					//YC̍ŏXWRlXg
	float		   *m_pafMaxR;					//YC̍őXWRlXg
	float		   *m_pafMinG;					//YC̍ŏXWGlXg
	float		   *m_pafMaxG;					//YC̍őXWGlXg
	float		   *m_pafMinB;					//YC̍ŏXWBlXg
	float		   *m_pafMaxB;					//YC̍őXWBlXg

	CMatrixMan4		m_mMaster;					//}X^[s
	CMatrixMan4		m_mWorld;					//[hϊs
	CMatrixMan4		m_mCamera;					//r[iJjϊs
	CMatrixMan4		m_mProjection;				//ˉeϊs
	CMatrixMan4		m_mViewPort;				//r[|[gϊs

	CVectorMan3		m_vEye;						//xNg((0.0,0.0,1.0)Œ)
												//xNg͎_̌Ă
												//ւ̃xNgƂȂ܂
	CVectorMan3		m_vLight;					//xNg(s)
												//xNgĂ
												//ւ̃xNgƂȂ܂
	CVectorMan3		m_vAmbientColor;			//
	CVectorMan3		m_vDiffuseColor;			//gU
	
private:


	//ItXN[obt@֘A̍쐬
	//쐬ɎsFALSEԂ܂
	BOOL CreateOffScreen(void);

	//ItXN[obt@֘A̍폜
	void DeleteOffScreen(void);

	//XN[tHg̍쐬
	void CreateScreenFont(void);

	//XN[tHg̍폜
	void DeleteScreenFont(void);

	//Op|S̖@xNg߂
	CVectorMan3 GetNormalVectorFromPolygon(CVectorMan4 v1,CVectorMan4 v2,CVectorMan4 v3);


	//_`
	inline void DrawPoint(int x,int y,RGB32_TYPE tColor);

	//_`(At@uht)
	inline void DrawPoint(int x,int y,RGB32_TYPE tColor,BYTE byAlpha);

	//_`(At@Zt)
	inline void DrawPointAddBlend(int x,int y,RGB32_TYPE tColor,BYTE byAlpha);

	//`(floatZ)
	void DrawLinefloat(int x1,int y1,int x2,int y2,RGB32_TYPE tColor);

	//`(doubleZ)
	inline void DrawLinedouble(int x1,int y1,int x2,int y2,RGB32_TYPE tColor);

	//`(u[n)
	void DrawLineDDA(int x1,int y1,int x2,int y2,RGB32_TYPE tColor);

	//tbgVF[fBOpXLC(GbW`FbN)
	void ScanlineForEdgeCheckForFlat(CVectorMan4 v1,CVectorMan4 v2);

	//tbgVF[fBOpXLC(GbW`FbN@u[n)
	void ScanlineForEdgeCheckDDAForFlat(CVectorMan4 v1,CVectorMan4 v2);

	//O[[VF[fBOpXLC(GbW`FbN@u[n)
	void ScanlineForEdgeCheckDDAForGouraud(CVertexMan v1,CVertexMan v2);



	//C[t[Ń|S`
	void DrawPolygonWithWireframe(CVertexMan *paVertexList,int *paiIndexList,int iPrimitiveCount);

	//tbgVF[fBOŃ|S`
	void DrawPolygonWithFlatShading(CVertexMan *paVertexList,int *paiIndexList,int iPrimitiveCount,
									bool bAddBlend = false,BYTE byAlpha = 255);

	//O[[VF[fBOŃ|S`
	void DrawPolygonWithGouraudShading(CVertexMan *paVertexList,int *paiIndexList,int iPrimitiveCount);

public:
	
	//RXgN^
	CRenderingMan(HWND hTargetWnd,int iScreenWidth,int iScreenHeight);

	//fXgN^
	virtual ~CRenderingMan();

	//ItXN[DC擾
	//ReleaseDCȂǂ͂Ȃŉ
	HDC GetDC(void) { return m_hOffScreenDC; }
	
	//ʃNA(IuXN[obt@w̐FœhԂ܂)
	BOOL Clear(COLORREF clBackColor);

	//u[tʃNA(IuXN[obt@w̐FœhԂ܂)
	//(Zobt@NA܂)
	//
	//byAlpha0`255ŁAu[̓hԂlł
	//bAddBlend = truȅꍇZɂȂ܂
	//
	BOOL ClearWithBlur(COLORREF clBackColor,BYTE byAlpha,bool bAddBlend = false);

	//A`GCAXtYȕ`(1̂)Ȃxł
	//
	//`搬ɂ͎̕ւXWItZbgԂ܂
    //UINT uiChar̓}`oCgR[h̐l_mbsnextc((const unsigned char*)"A")
	//ȂǂŎw肵ĂB
	//
	int DrawMoji(int x,int y,UINT uiChar,RGB32_TYPE tColor,bool bAddBlend = false);

	//A`GCAXtYȕ`恦Ȃxł
	void DrawString(int x,int y,char *pszString,RGB32_TYPE tColor,bool bAddBlend = false);

	//`悵ۂ̕`͈͂擾
	SIZE GetDrawStringSize(char *pszString);

	//w肵̕`敝擾
	//UINT uiChar̓}`oCgR[h̐l_mbsnextc((const unsigned char*)"A")
	//ȂǂŎw肵ĂB
	int GetDrawMojiWidth(UINT uiMoji);

	//tHg̕ύX
	void ChangeFont(LOGFONT *pLogFont);

	//xNg̍XV
	void SetLightVector(float fX,float fY,float fZ)
	{
		m_vLight.SetValue(fX,fY,fZ);
		m_vLight.Normalize();
	}

	//̍XV
	//͈ÂɂFt邽߂
	//  ̋łBꂪ傫Ȃ肷(0.5ȏ
	//  Ƃ)eʂł̔ZWȂȂ̂ŒӁI
	void SetAmbientLight(float fR,float fG,float fB)
	{
		m_vAmbientColor.SetValue(fR,fG,fB);
	}

	//gU̍XV
	//gU|S̖ʂ̐F̔ZWɊ֌W܂B
	//  |Sʂ̐F͊Ō܂ƎvĂB
	void SetDiffuseLight(float fR,float fG,float fB)
	{
		m_vDiffuseColor.SetValue(fR,fG,fB);
	}

	//[hϊsZbg
	void SetWorldMatrix(CMatrixMan4 matrix)
	{
		m_mWorld = matrix;
	}

	//r[(J)ϊsZbg
	void SetCameraMatrix(CMatrixMan4 matrix)
	{
		m_mCamera = matrix;
	}

	//ˉeϊsZbg
	void SetProjectionMatrix(CMatrixMan4 matrix)
	{
		m_mProjection = matrix;
	}

	//r[|[g̐ݒ
	//
	//float fX				r[|[ĝwW
	//float fY				r[|[ĝxW
	//float fWidth			r[|[g̕
	//float fHeight			r[|[g̍
	//
	void SetViewPort(float fX,float fY,float fWidth,float fHeight);

	//v~eBu`
	//
	//CVertex *paVertex	    IuWFNg̒_f[^Xgւ̃|C^
	//int iVertexCount		_Xǧ
	//int *paiIndexList		_ԃXgւ̃|C^
	//int iPrimitiveCount	v~eBu̐
	//						Pv~eBu͂R_̎Op`Ȃ̂
	//						_ԃXǧRŊ
	//RENDER_TYPE_ENUM
	// eRenderType			|S̕`@
	//bool bAddBlend        Zw(tbgVF[fBÔݗL)
	//BYTE byAlpha			l(0`255 tbgVF[fBÔݗL)
	//
	void DrawIndexedPrimitive(CVertexMan *paVertex,int iVertexCount,
							  int *paiIndexList,int iPrimitiveCount,
							  RENDER_TYPE_ENUM eRenderType,
							  bool bAddBlend = false,BYTE byAlpha = 255);

	//_OʂEChEɓ]
	BOOL Draw3dWorld(BOOL bDrawFPS = FALSE);

};
//---------------------------------------------------------------------------