//---------------------------------------------------------------------------
// Madoka Demo 2006 ܂ǂ̎Ȗ3Df2006
//
// CSceneManBase.h f̐is͉d؂I@V[}x[XNXwb_[
//
//                 V[}x[X́Af̊eV[̐isC
//                 V[}NX̋ʊOC^[tF[XAx[X
//                 NXłB
//                 ̃fŗpV[NX͑SẴx[XNX
//                 hNXɂȂ܂B
//                 ̃x[XNXł͖(?)oƂ͂ł
//                 B
//                 AʂốAhNX݌vcc
//                 [ȁ[[[[łIIi
// 
// Programmed by Mikio Kusaka With Microsoft Visual C++ .Net2003
//
//---------------------------------------------------------------------------
#pragma once	//ł̃wb_t@C1񂵂ǂ܂Ȃ悤ɂĂ邪A
				//  gȂRpĈ݂ŁAӂ邱ƁB
				//  ŋ߂̎vȃRpC(VC,gcc,bc,CodeWarriorjł͎g݂B

#include <vector>	//STLVector
#include "CRenderingMan.h"
#include "screen.h"
//---------------------------------------------------------------------------
// 萔 
//---------------------------------------------------------------------------
#define SCENE_OBJECT_WORK_SPACE		(128)		//IuWFNgf[^̃[N
												//GATCY
												//̃[NGA̕e
												//IuWFNg̐p\̂
												//LXgėp܂B



//---------------------------------------------------------------------------
// \̒萔 
//---------------------------------------------------------------------------
//IuWFNgǗpʍ\
#pragma pack(1)
typedef struct tag_Object_State_Type
{
	//IuWFNg֐^|C^`
	typedef void (*LPOBJECT_FUNC)(CRenderingMan *pRenderingMan,
								  tag_Object_State_Type *pObjectState,
								  DWORD dwNowTime);

	C3dObjectManBase	*pObject;			//ǗΏۃIuWFNg

	DWORD				 dwAliveTime[2];	//IuWFNg(ms)
											//V[JňoߎԂŕ\
											//IuWFNg\͈

	CVectorMan3			 StartPos;			//IuWFNg̊ʒu(Jnʒu)
	CVectorMan3			 TargetPos;			//IuWFNg̓BڕWʒu
	
	LPOBJECT_FUNC		 pFunc;				//IuWFNg֐ւ̃|C^

	BYTE abyWork[SCENE_OBJECT_WORK_SPACE];	//eIuWFNgǗ̃[NGA

	//RXgN^
	tag_Object_State_Type()
	{
		//ȍ
		pObject        = NULL;
		dwAliveTime[0] = 0;
		dwAliveTime[1] = 0;
		pFunc          = 0;
	}

	//fXgN^
	~tag_Object_State_Type()
	{
		if(pObject != NULL)
		{	delete pObject;		}
	}

} OBJECT_STATE_TYPE;
#pragma pack()


//---------------------------------------------------------------------------
// f[^^萔 
//---------------------------------------------------------------------------
typedef std::vector<OBJECT_STATE_TYPE*> SCENE_OBJECT_VECTOR;

//IuWFNg֐^|C^`
typedef void (*LPOBJECT_FUNC)(CRenderingMan *pRenderingMan,
							  OBJECT_STATE_TYPE *pObjectState,DWORD dwNowTime);


//---------------------------------------------------------------------------
// NX` 
//---------------------------------------------------------------------------
//V[NXC^[tF[XS V[}x[X
//
class CSceneManBase
{
protected:

	CRenderingMan		*m_pRenderingMan;		//_O}̃|C^

	SCENE_OBJECT_VECTOR	 m_vecObjectList;		//V[ŎgpIuWFNg
												//Ǘp\̃|C^Xg

	bool				 m_bSceneStart;			//V[JntO
	bool				 m_bSceneEnd;			//V[ItO


	//V[IuWFNg̍폜
	void DeleteSceneObject(void)
	{
		SCENE_OBJECT_VECTOR::iterator ite;
		for(ite  = m_vecObjectList.begin();
			ite != m_vecObjectList.end();++ite)
		{
			delete *ite;	//Ǘ̍폜

			//3DIuWFNg͊Ǘ\̂̃fXgN^
			//  폜܂B
		}
		m_vecObjectList.clear();
	}

public:

	//RXgN^
	CSceneManBase(CRenderingMan *pRenderingMan)
	{
		//ȍ
		m_pRenderingMan = pRenderingMan;
		m_bSceneStart   = false;
		m_bSceneEnd     = false;
		
		m_vecObjectList.clear();	//ȂĂǋCI		
	}

	//fXgN^
	virtual ~CSceneManBase()
	{
		//V[IuWFNg̍폜
		DeleteSceneObject();
	}

	//V[\z`FbN
	bool IsSceneCreate(void){ return m_bSceneStart; }

	//V[I`FbN
	bool IsSceneFinish(void){ return m_bSceneEnd;   }



	//ȉ͔hNXŃI[o[ChK{̏z֐

	//V[IuWFNg̍\z
	virtual void CreateScene(void) = 0;

	//V[IuWFNg̍폜
	virtual void DeleteScene(void) = 0;

	//V[̕`
	//DWORD dwTime̓V[Jňoߎ(ms)
	virtual void DrawScene(DWORD dwTime) = 0;

};
//---------------------------------------------------------------------------

//V[eXgNX
class CTestSceneMan : public CSceneManBase
{
protected:



public:

	//RXgN^
	CTestSceneMan(CRenderingMan *pRenderingMan) : CSceneManBase(pRenderingMan)
	{			
	}

	//fXgN^
	~CTestSceneMan()
	{
	}

	//ȉ͔hNXŃI[o[ChK{̏z֐

	//V[IuWFNg̍\z
	virtual void CreateScene(void);

	//V[IuWFNg̍폜
	virtual void DeleteScene(void);

	//V[̕`
	//DWORD dwTime̓V[Jňoߎ(ms)
	virtual void DrawScene(DWORD dwTime);

};

